import{S as B1,i as J1,s as K1,e as c,k as h,w as v,t as s,M as Q1,c as l,d as r,m as f,a as n,x as b,h as o,b as k,G as e,g as $,y as w,q as y,o as j,B as A,v as X1,L as C}from"../../chunks/vendor-hf-doc-builder.js";import{T as Re}from"../../chunks/Tip-hf-doc-builder.js";import{D as T}from"../../chunks/Docstring-hf-doc-builder.js";import{C as D}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as B}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as z}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Z1(E){let p,g;return{c(){p=c("p"),g=s("Step three is optional, but considered a best practice.")},l(m){p=l(m,"P",{});var i=n(p);g=o(i,"Step three is optional, but considered a best practice."),i.forEach(r)},m(m,i){$(m,p,i),e(p,g)},d(m){m&&r(p)}}}function e2(E){let p,g;return{c(){p=c("p"),g=s("Step five is mandatory when using distributed evaluation")},l(m){p=l(m,"P",{});var i=n(p);g=o(i,"Step five is mandatory when using distributed evaluation"),i.forEach(r)},m(m,i){$(m,p,i),e(p,g)},d(m){m&&r(p)}}}function t2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=2)
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

with accelerator.accumulate():
    for input, output in dataloader:
        outputs = model(input)
        loss = loss_func(outputs)
        loss.backward()
        optimizer.step()
        scheduler.step()
        optimizer.zero_grad()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.accumulate():
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, output <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>        outputs = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>        loss = loss_func(outputs)
<span class="hljs-meta">... </span>        loss.backward()
<span class="hljs-meta">... </span>        optimizer.step()
<span class="hljs-meta">... </span>        scheduler.step()
<span class="hljs-meta">... </span>        optimizer.zero_grad()`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function a2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(mixed_precision="fp16")
with accelerator.autocast():
    train()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.autocast():
<span class="hljs-meta">... </span>    train()`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function r2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=1)
outputs = model(inputs)
loss = loss_fn(outputs, labels)
accelerator.backward(loss)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">1</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = loss_fn(outputs, labels)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.backward(loss)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function s2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
model, optimizer, scheduler = ...
model, optimizer, scheduler = accelerator.prepare(model, optimizer, scheduler)
accelerator.free_memory()
del model, optimizer, scheduler`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, scheduler = ...
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, scheduler = accelerator.prepare(model, optimizer, scheduler)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.free_memory()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">del</span> model, optimizer, scheduler`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function o2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=2)
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

for input, target in dataloader:
    optimizer.zero_grad()
    output = model(input)
    loss = loss_func(output, target)
    accelerator.backward(loss)
    if accelerator.sync_gradients:
        accelerator.clip_grad_norm_(model.parameters(), max_grad_norm)
    optimizer.step()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, target <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>    optimizer.zero_grad()
<span class="hljs-meta">... </span>    output = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>    loss = loss_func(output, target)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">if</span> accelerator.sync_gradients:
<span class="hljs-meta">... </span>        accelerator.clip_grad_norm_(model.parameters(), max_grad_norm)
<span class="hljs-meta">... </span>    optimizer.step()`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function c2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=2)
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

for input, target in dataloader:
    optimizer.zero_grad()
    output = model(input)
    loss = loss_func(output, target)
    accelerator.backward(loss)
    if accelerator.sync_gradients:
        accelerator.clip_grad_value_(model.parameters(), clip_value)
    optimizer.step()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, target <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>    optimizer.zero_grad()
<span class="hljs-meta">... </span>    output = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>    loss = loss_func(output, target)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">if</span> accelerator.sync_gradients:
<span class="hljs-meta">... </span>        accelerator.clip_grad_value_(model.parameters(), clip_value)
<span class="hljs-meta">... </span>    optimizer.step()`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function l2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
model, optimizer, scheduler = ...
model, optimizer, scheduler = accelerator.prepare(model, optimizer, scheduler)
accelerator.free_memory()
del model, optimizer, scheduler`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, scheduler = ...
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, scheduler = accelerator.prepare(model, optimizer, scheduler)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.free_memory()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">del</span> model, optimizer, scheduler`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function n2(E){let p,g,m,i,u;return i=new D({props:{code:`# Assuming four processes
import torch
from accelerate import Accelerator

accelerator = Accelerator()
process_tensor = torch.tensor([accelerator.process_index])
gathered_tensor = accelerator.gather(process_tensor)
gathered_tensor`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming four processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>process_tensor = torch.tensor([accelerator.process_index])
<span class="hljs-meta">&gt;&gt;&gt; </span>gathered_tensor = accelerator.gather(process_tensor)
<span class="hljs-meta">&gt;&gt;&gt; </span>gathered_tensor
tensor([<span class="hljs-number">0</span>, <span class="hljs-number">1</span>, <span class="hljs-number">2</span>, <span class="hljs-number">3</span>])`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function p2(E){let p,g,m,i,u;return i=new D({props:{code:`# Assuming two processes, with a batch size of 5 on a dataset with 9 samples
import torch
from accelerate import Accelerator

accelerator = Accelerator()
dataloader = torch.utils.data.DataLoader(range(9), batch_size=5)
dataloader = accelerator.prepare(dataloader)
batch = next(iter(dataloader))
gathered_items = accelerator.gather_for_metrics(batch)
len(gathered_items)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two processes, with a batch size of 5 on a dataset with 9 samples</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader = torch.utils.data.DataLoader(<span class="hljs-built_in">range</span>(<span class="hljs-number">9</span>), batch_size=<span class="hljs-number">5</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader = accelerator.prepare(dataloader)
<span class="hljs-meta">&gt;&gt;&gt; </span>batch = <span class="hljs-built_in">next</span>(<span class="hljs-built_in">iter</span>(dataloader))
<span class="hljs-meta">&gt;&gt;&gt; </span>gathered_items = accelerator.gather_for_metrics(batch)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">len</span>(gathered_items)
<span class="hljs-number">9</span>`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function i2(E){let p,g,m,i,u;return i=new D({props:{code:`import torch
from accelerate import Accelerator

accelerator = Accelerator()
net = torch.nn.Linear(2, 2)
net = accelerator.prepare(net)
state_dict = accelerator.get_state_dict(net)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>net = torch.nn.Linear(<span class="hljs-number">2</span>, <span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>net = accelerator.prepare(net)
<span class="hljs-meta">&gt;&gt;&gt; </span>state_dict = accelerator.get_state_dict(net)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function d2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(log_with="tensorboard")
accelerator.init_trackers("my_project")
tensorboard_tracker = accelerator.get_tracker("tensorboard")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(log_with=<span class="hljs-string">&quot;tensorboard&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.init_trackers(<span class="hljs-string">&quot;my_project&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tensorboard_tracker = accelerator.get_tracker(<span class="hljs-string">&quot;tensorboard&quot;</span>)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function m2(E){let p,g,m,i;return{c(){p=c("p"),g=c("code"),m=s("join_uneven_inputs"),i=s(` is only supported for Distributed Data Parallel training on multiple GPUs. For any other
configuration, this method will have no effect.`)},l(u){p=l(u,"P",{});var t=n(p);g=l(t,"CODE",{});var d=n(g);m=o(d,"join_uneven_inputs"),d.forEach(r),i=o(t,` is only supported for Distributed Data Parallel training on multiple GPUs. For any other
configuration, this method will have no effect.`),t.forEach(r)},m(u,t){$(u,p,t),e(p,g),e(g,m),e(p,i)},d(u){u&&r(p)}}}function h2(E){let p,g,m,i,u;return{c(){p=c("p"),g=s("Overidding "),m=c("code"),i=s("even_batches"),u=s(" will not affect iterable-style data loaders.")},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Overidding "),m=l(d,"CODE",{});var L=n(m);i=o(L,"even_batches"),L.forEach(r),u=o(d," will not affect iterable-style data loaders."),d.forEach(r)},m(t,d){$(t,p,d),e(p,g),e(p,m),e(m,i),e(p,u)},d(t){t&&r(p)}}}function f2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(even_batches=True)
ddp_model, optimizer, dataloader = accelerator.prepare(model, optimizer, dataloader)

with accelerator.join_uneven_inputs([ddp_model], even_batches=False):
    for input, output in dataloader:
        outputs = model(input)
        loss = loss_func(outputs)
        loss.backward()
        optimizer.step()
        optimizer.zero_grad()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(even_batches=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ddp_model, optimizer, dataloader = accelerator.prepare(model, optimizer, dataloader)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.join_uneven_inputs([ddp_model], even_batches=<span class="hljs-literal">False</span>):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, output <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>        outputs = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>        loss = loss_func(outputs)
<span class="hljs-meta">... </span>        loss.backward()
<span class="hljs-meta">... </span>        optimizer.step()
<span class="hljs-meta">... </span>        optimizer.zero_grad()`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function u2(E){let p,g,m,i,u;return{c(){p=c("p"),g=s("Should only be used in conjunction with "),m=c("a"),i=s("Accelerator.save_state()"),u=s("."),this.h()},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Should only be used in conjunction with "),m=l(d,"A",{href:!0});var L=n(m);i=o(L,"Accelerator.save_state()"),L.forEach(r),u=o(d,"."),d.forEach(r),this.h()},h(){k(m,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.save_state")},m(t,d){$(t,p,d),e(p,g),e(p,m),e(m,i),e(p,u)},d(t){t&&r(p)}}}function g2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
model, optimizer, lr_scheduler = ...
model, optimizer, lr_scheduler = accelerator.prepare(model, optimizer, lr_scheduler)
accelerator.load_state("my_checkpoint")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, lr_scheduler = ...
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, lr_scheduler = accelerator.prepare(model, optimizer, lr_scheduler)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.load_state(<span class="hljs-string">&quot;my_checkpoint&quot;</span>)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function _2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
with accelerator.local_main_process_first():
    # This will be printed first by local process 0 then in a seemingly
    # random order by the other processes.
    print(f"This will be printed by process {accelerator.local_process_index}")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.local_main_process_first():
<span class="hljs-meta">... </span>    <span class="hljs-comment"># This will be printed first by local process 0 then in a seemingly</span>
<span class="hljs-meta">... </span>    <span class="hljs-comment"># random order by the other processes.</span>
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;This will be printed by process <span class="hljs-subst">{accelerator.local_process_index}</span>&quot;</span>)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function $2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
with accelerator.main_process_first():
    # This will be printed first by process 0 then in a seemingly
    # random order by the other processes.
    print(f"This will be printed by process {accelerator.process_index}")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.main_process_first():
<span class="hljs-meta">... </span>    <span class="hljs-comment"># This will be printed first by process 0 then in a seemingly</span>
<span class="hljs-meta">... </span>    <span class="hljs-comment"># random order by the other processes.</span>
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;This will be printed by process <span class="hljs-subst">{accelerator.process_index}</span>&quot;</span>)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function v2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
dataloader, model, optimizer = accelerator.prepare(dataloader, model, optimizer)
input_a = next(iter(dataloader))
input_b = next(iter(dataloader))

with accelerator.no_sync():
    outputs = model(input_a)
    loss = loss_func(outputs)
    accelerator.backward(loss)
    # No synchronization across processes, only accumulate gradients
outputs = model(input_b)
accelerator.backward(loss)
# Synchronization across all processes
optimizer.step()
optimizer.zero_grad()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer = accelerator.prepare(dataloader, model, optimizer)
<span class="hljs-meta">&gt;&gt;&gt; </span>input_a = <span class="hljs-built_in">next</span>(<span class="hljs-built_in">iter</span>(dataloader))
<span class="hljs-meta">&gt;&gt;&gt; </span>input_b = <span class="hljs-built_in">next</span>(<span class="hljs-built_in">iter</span>(dataloader))

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.no_sync():
<span class="hljs-meta">... </span>    outputs = model(input_a)
<span class="hljs-meta">... </span>    loss = loss_func(outputs)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    <span class="hljs-comment"># No synchronization across processes, only accumulate gradients</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(input_b)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.backward(loss)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Synchronization across all processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer.step()
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer.zero_grad()`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function b2(E){let p,g,m,i,u;return i=new D({props:{code:`# Assume we have 4 processes.
from accelerate import Accelerator

accelerator = Accelerator()


@accelerator.on_last_process
def print_something():
    print(f"Printed on process {accelerator.process_index}")


print_something()
"Printed on process 3"`,highlighted:`<span class="hljs-comment"># Assume we have 4 processes.</span>
<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

accelerator = Accelerator()


<span class="hljs-meta">@accelerator.on_last_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Printed on process <span class="hljs-subst">{accelerator.process_index}</span>&quot;</span>)


print_something()
<span class="hljs-string">&quot;Printed on process 3&quot;</span>`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function w2(E){let p,g,m,i,u;return i=new D({props:{code:`# Assume we have 2 servers with 4 processes each.
from accelerate import Accelerator

accelerator = Accelerator()


@accelerator.on_local_main_process
def print_something():
    print("This will be printed by process 0 only on each server.")


print_something()
# On server 1:
"This will be printed by process 0 only"
# On server 2:
"This will be printed by process 0 only"`,highlighted:`<span class="hljs-comment"># Assume we have 2 servers with 4 processes each.</span>
<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

accelerator = Accelerator()


<span class="hljs-meta">@accelerator.on_local_main_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;This will be printed by process 0 only on each server.&quot;</span>)


print_something()
<span class="hljs-comment"># On server 1:</span>
<span class="hljs-string">&quot;This will be printed by process 0 only&quot;</span>
<span class="hljs-comment"># On server 2:</span>
<span class="hljs-string">&quot;This will be printed by process 0 only&quot;</span>`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function y2(E){let p,g,m,i,u;return i=new D({props:{code:`# Assume we have 2 servers with 4 processes each.
from accelerate import Accelerator

accelerator = Accelerator()


@accelerator.on_local_process(local_process_index=2)
def print_something():
    print(f"Printed on process {accelerator.local_process_index}")


print_something()
# On server 1:
"Printed on process 2"
# On server 2:
"Printed on process 2"`,highlighted:`<span class="hljs-comment"># Assume we have 2 servers with 4 processes each.</span>
<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

accelerator = Accelerator()


<span class="hljs-meta">@accelerator.on_local_process(<span class="hljs-params">local_process_index=<span class="hljs-number">2</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Printed on process <span class="hljs-subst">{accelerator.local_process_index}</span>&quot;</span>)


print_something()
<span class="hljs-comment"># On server 1:</span>
<span class="hljs-string">&quot;Printed on process 2&quot;</span>
<span class="hljs-comment"># On server 2:</span>
<span class="hljs-string">&quot;Printed on process 2&quot;</span>`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function j2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()


@accelerator.on_main_process
def print_something():
    print("This will be printed by process 0 only.")


print_something()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()


<span class="hljs-meta">&gt;&gt;&gt; </span>@accelerator.on_main_process
<span class="hljs-meta">... </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;This will be printed by process 0 only.&quot;</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span>print_something()
<span class="hljs-string">&quot;This will be printed by process 0 only&quot;</span>`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function A2(E){let p,g,m,i,u;return i=new D({props:{code:`# Assume we have 4 processes.
from accelerate import Accelerator

accelerator = Accelerator()


@accelerator.on_process(process_index=2)
def print_something():
    print(f"Printed on process {accelerator.process_index}")


print_something()
"Printed on process 2"`,highlighted:`<span class="hljs-comment"># Assume we have 4 processes.</span>
<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

accelerator = Accelerator()


<span class="hljs-meta">@accelerator.on_process(<span class="hljs-params">process_index=<span class="hljs-number">2</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Printed on process <span class="hljs-subst">{accelerator.process_index}</span>&quot;</span>)


print_something()
<span class="hljs-string">&quot;Printed on process 2&quot;</span>`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function k2(E){let p,g,m,i,u;return i=new D({props:{code:`# Assuming two processes, with the first processes having a tensor of size 1 and the second of size 2
import torch
from accelerate import Accelerator

accelerator = Accelerator()
process_tensor = torch.arange(accelerator.process_index + 1).to(accelerator.device)
padded_tensor = accelerator.pad_across_processes(process_tensor)
padded_tensor.shape`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two processes, with the first processes having a tensor of size 1 and the second of size 2</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>process_tensor = torch.arange(accelerator.process_index + <span class="hljs-number">1</span>).to(accelerator.device)
<span class="hljs-meta">&gt;&gt;&gt; </span>padded_tensor = accelerator.pad_across_processes(process_tensor)
<span class="hljs-meta">&gt;&gt;&gt; </span>padded_tensor.shape
torch.Size([<span class="hljs-number">2</span>])`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function E2(E){let p,g;return{c(){p=c("p"),g=s("You don\u2019t need to prepare a model if you only use it for inference without any kind of mixed precision")},l(m){p=l(m,"P",{});var i=n(p);g=o(i,"You don\u2019t need to prepare a model if you only use it for inference without any kind of mixed precision"),i.forEach(r)},m(m,i){$(m,p,i),e(p,g)},d(m){m&&r(p)}}}function x2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
# Assume a model, optimizer, data_loader and scheduler are defined
model, optimizer, data_loader, scheduler = accelerator.prepare(model, optimizer, data_loader, scheduler)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assume a model, optimizer, data_loader and scheduler are defined</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, data_loader, scheduler = accelerator.prepare(model, optimizer, data_loader, scheduler)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function P2(E){let p,g,m,i,u;return i=new D({props:{code:`import torch
from accelerate import Accelerator

accelerator = Accelerator()
data_loader = torch.utils.data.DataLoader(...)
data_loader = accelerator.prepare_data_loader(data_loader, device_placement=True)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>data_loader = torch.utils.data.DataLoader(...)
<span class="hljs-meta">&gt;&gt;&gt; </span>data_loader = accelerator.prepare_data_loader(data_loader, device_placement=<span class="hljs-literal">True</span>)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function D2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
# Assume a model is defined
model = accelerator.prepare_model(model)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assume a model is defined</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = accelerator.prepare_model(model)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function T2(E){let p,g,m,i,u;return i=new D({props:{code:`import torch
from accelerate import Accelerator

accelerator = Accelerator()
optimizer = torch.optim.Adam(...)
optimizer = accelerator.prepare_optimizer(optimizer, device_placement=True)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer = torch.optim.Adam(...)
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer = accelerator.prepare_optimizer(optimizer, device_placement=<span class="hljs-literal">True</span>)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function z2(E){let p,g,m,i,u;return i=new D({props:{code:`import torch
from accelerate import Accelerator

accelerator = Accelerator()
optimizer = torch.optim.Adam(...)
scheduler = torch.optim.lr_scheduler.LambdaLR(optimizer, ...)
scheduler = accelerator.prepare_scheduler(scheduler)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer = torch.optim.Adam(...)
<span class="hljs-meta">&gt;&gt;&gt; </span>scheduler = torch.optim.lr_scheduler.LambdaLR(optimizer, ...)
<span class="hljs-meta">&gt;&gt;&gt; </span>scheduler = accelerator.prepare_scheduler(scheduler)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function C2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
accelerator.print("Hello world!")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;Hello world!&quot;</span>)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function O2(E){let p,g,m,i,u;return i=new D({props:{code:`# Assuming two processes
import torch
from accelerate import Accelerator

accelerator = Accelerator()
process_tensor = torch.arange(accelerator.num_processes) + 1 + (2 * accelerator.process_index)
process_tensor = process_tensor.to(accelerator.device)
reduced_tensor = accelerator.reduce(process_tensor, reduction="sum")
reduced_tensor`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>process_tensor = torch.arange(accelerator.num_processes) + <span class="hljs-number">1</span> + (<span class="hljs-number">2</span> * accelerator.process_index)
<span class="hljs-meta">&gt;&gt;&gt; </span>process_tensor = process_tensor.to(accelerator.device)
<span class="hljs-meta">&gt;&gt;&gt; </span>reduced_tensor = accelerator.reduce(process_tensor, reduction=<span class="hljs-string">&quot;sum&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>reduced_tensor
tensor([<span class="hljs-number">4</span>, <span class="hljs-number">6</span>])`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function L2(E){let p,g,m,i,u,t,d,L,Ge,ft,J;return{c(){p=c("p"),g=s("Every "),m=c("code"),i=s("object"),u=s(" must have a "),t=c("code"),d=s("load_state_dict"),L=s(" and "),Ge=c("code"),ft=s("state_dict"),J=s(" function to be stored.")},l(Ve){p=l(Ve,"P",{});var q=n(p);g=o(q,"Every "),m=l(q,"CODE",{});var Ws=n(m);i=o(Ws,"object"),Ws.forEach(r),u=o(q," must have a "),t=l(q,"CODE",{});var Fs=n(t);d=o(Fs,"load_state_dict"),Fs.forEach(r),L=o(q," and "),Ge=l(q,"CODE",{});var ar=n(Ge);ft=o(ar,"state_dict"),ar.forEach(r),J=o(q," function to be stored."),q.forEach(r)},m(Ve,q){$(Ve,p,q),e(p,g),e(p,m),e(m,i),e(p,u),e(p,t),e(t,d),e(p,L),e(p,Ge),e(Ge,ft),e(p,J)},d(Ve){Ve&&r(p)}}}function S2(E){let p,g,m,i,u;return i=new D({props:{code:'from accelerate import Accelerator\n\naccelerator = Accelerator()\n# Assume `CustomObject` has a `state_dict` and `load_state_dict` function.\nobj = CustomObject()\naccelerator.register_for_checkpointing(obj)\naccelerator.save_state("checkpoint.pt")',highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator\n\n<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()\n<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assume `CustomObject` has a `state_dict` and `load_state_dict` function.</span>\n<span class="hljs-meta">&gt;&gt;&gt; </span>obj = CustomObject()\n<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.register_for_checkpointing(obj)\n<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.save_state(<span class="hljs-string">&quot;checkpoint.pt&quot;</span>)'}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function I2(E){let p,g,m,i,u;return{c(){p=c("p"),g=s("Should only be used in conjunction with "),m=c("a"),i=s("Accelerator.register_save_state_pre_hook()"),u=s(`. Can be useful to load
configurations in addition to model weights. Can also be used to overwrite model loading with a customized
method. In this case, make sure to remove already loaded models from the models list.`),this.h()},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Should only be used in conjunction with "),m=l(d,"A",{href:!0});var L=n(m);i=o(L,"Accelerator.register_save_state_pre_hook()"),L.forEach(r),u=o(d,`. Can be useful to load
configurations in addition to model weights. Can also be used to overwrite model loading with a customized
method. In this case, make sure to remove already loaded models from the models list.`),d.forEach(r),this.h()},h(){k(m,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.register_save_state_pre_hook")},m(t,d){$(t,p,d),e(p,g),e(p,m),e(m,i),e(p,u)},d(t){t&&r(p)}}}function q2(E){let p,g,m,i,u;return{c(){p=c("p"),g=s("Should only be used in conjunction with "),m=c("a"),i=s("Accelerator.register_load_state_pre_hook()"),u=s(`. Can be useful to save
configurations in addition to model weights. Can also be used to overwrite model saving with a customized
method. In this case, make sure to remove already loaded weights from the weights list.`),this.h()},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Should only be used in conjunction with "),m=l(d,"A",{href:!0});var L=n(m);i=o(L,"Accelerator.register_load_state_pre_hook()"),L.forEach(r),u=o(d,`. Can be useful to save
configurations in addition to model weights. Can also be used to overwrite model saving with a customized
method. In this case, make sure to remove already loaded weights from the weights list.`),d.forEach(r),this.h()},h(){k(m,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.register_load_state_pre_hook")},m(t,d){$(t,p,d),e(p,g),e(p,m),e(m,i),e(p,u)},d(t){t&&r(p)}}}function N2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
arr = [0, 1, 2, 3]
accelerator.save(arr, "array.pkl")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>arr = [<span class="hljs-number">0</span>, <span class="hljs-number">1</span>, <span class="hljs-number">2</span>, <span class="hljs-number">3</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.save(arr, <span class="hljs-string">&quot;array.pkl&quot;</span>)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function M2(E){let p,g;return{c(){p=c("p"),g=s(`Should only be used when wanting to save a checkpoint during training and restoring the state in the same
environment.`)},l(m){p=l(m,"P",{});var i=n(p);g=o(i,`Should only be used when wanting to save a checkpoint during training and restoring the state in the same
environment.`),i.forEach(r)},m(m,i){$(m,p,i),e(p,g)},d(m){m&&r(p)}}}function U2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
model, optimizer, lr_scheduler = ...
model, optimizer, lr_scheduler = accelerator.prepare(model, optimizer, lr_scheduler)
accelerator.save_state(output_dir="my_checkpoint")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, lr_scheduler = ...
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, lr_scheduler = accelerator.prepare(model, optimizer, lr_scheduler)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.save_state(output_dir=<span class="hljs-string">&quot;my_checkpoint&quot;</span>)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function R2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

for input, target in accelerator.skip_first_batches(dataloader, num_batches=2):
    optimizer.zero_grad()
    output = model(input)
    loss = loss_func(output, target)
    accelerator.backward(loss)
    optimizer.step()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, target <span class="hljs-keyword">in</span> accelerator.skip_first_batches(dataloader, num_batches=<span class="hljs-number">2</span>):
<span class="hljs-meta">... </span>    optimizer.zero_grad()
<span class="hljs-meta">... </span>    output = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>    loss = loss_func(output, target)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    optimizer.step()`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function G2(E){let p,g,m,i,u;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
model, optimizer = accelerator.prepare(model, optimizer)
outputs = model(inputs)
loss = loss_fn(outputs, labels)
accelerator.backward(loss)
accelerator.unscale_gradients(optimizer=optimizer)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer = accelerator.prepare(model, optimizer)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = loss_fn(outputs, labels)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.backward(loss)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.unscale_gradients(optimizer=optimizer)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function V2(E){let p,g,m,i,u;return i=new D({props:{code:`# Assuming two GPU processes
from torch.nn.parallel import DistributedDataParallel
from accelerate import Accelerator

accelerator = Accelerator()
model = accelerator.prepare(MyModel())
print(model.__class__.__name__)

model = accelerator.unwrap_model(model)
print(model.__class__.__name__)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two GPU processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> torch.nn.parallel <span class="hljs-keyword">import</span> DistributedDataParallel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model = accelerator.prepare(MyModel())
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(model.__class__.__name__)
DistributedDataParallel

<span class="hljs-meta">&gt;&gt;&gt; </span>model = accelerator.unwrap_model(model)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(model.__class__.__name__)
MyModel`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function W2(E){let p,g,m,i,u;return i=new D({props:{code:`# Assuming two GPU processes
import time
from accelerate import Accelerator

accelerator = Accelerator()
if accelerator.is_main_process:
    time.sleep(2)
else:
    print("I'm waiting for the main process to finish its sleep...")
accelerator.wait_for_everyone()
# Should print on every process at the same time
print("Everyone is here")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two GPU processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> time
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">if</span> accelerator.is_main_process:
<span class="hljs-meta">... </span>    time.sleep(<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">else</span>:
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;I&#x27;m waiting for the main process to finish its sleep...&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.wait_for_everyone()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Should print on every process at the same time</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;Everyone is here&quot;</span>)`}}),{c(){p=c("p"),g=s("Example:"),m=h(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);g=o(d,"Example:"),d.forEach(r),m=f(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,g),$(t,m,d),w(i,t,d),u=!0},p:C,i(t){u||(y(i.$$.fragment,t),u=!0)},o(t){j(i.$$.fragment,t),u=!1},d(t){t&&r(p),t&&r(m),A(i,t)}}}function F2(E){let p,g,m,i,u,t,d,L,Ge,ft,J,Ve,q,Ws,Fs,ar,We,ut,Ko,rr,Si,Qo,Ii,np,Hs,qi,pp,he,Fe,Ni,Ys,Mi,Ui,Xo,Ri,Gi,Vi,sr,Wi,Bs,Fi,Hi,Yi,pe,Bi,Zo,Ji,Ki,ec,Qi,Xi,tc,Zi,ed,ip,gt,dp,He,_t,td,ac,ad,rd,rc,sd,od,Js,cd,Ks,ld,mp,$t,hp,vt,nd,sc,pd,id,fp,Ye,bt,oc,or,dd,cc,md,up,Be,wt,lc,cr,hd,nc,fd,gp,Je,pc,ud,gd,Qs,_d,$d,_p,lr,$p,Ke,yt,ic,nr,vd,dc,bd,vp,Qe,jt,mc,pr,wd,hc,yd,bp,At,jd,fc,Ad,kd,wp,ir,yp,kt,Ed,Xs,xd,Pd,jp,dr,Ap,Xe,Et,uc,mr,Dd,gc,Td,kp,xt,zd,_c,Cd,Od,Ep,hr,xp,Pt,Ld,Zs,Sd,Id,Pp,fr,Dp,Ze,Dt,$c,ur,qd,vc,Nd,Tp,eo,Md,zp,gr,Cp,_r,Op,et,Tt,bc,$r,Ud,wc,Rd,Lp,zt,Gd,to,Vd,Wd,Sp,tt,Ct,yc,vr,Fd,jc,Hd,Ip,Ot,Yd,ao,Bd,Jd,qp,br,Np,fe,Kd,ro,Qd,Xd,Ac,Zd,em,Mp,wr,Up,at,Lt,kc,yr,tm,Ec,am,Rp,Y,rm,St,sm,xc,om,cm,lm,Pc,nm,pm,It,im,Dc,dm,mm,hm,Tc,fm,Gp,rt,qt,zc,jr,um,Cc,gm,Vp,Nt,_m,so,$m,vm,Wp,Ar,Fp,st,Mt,Oc,kr,bm,Lc,wm,Hp,x,Er,ym,Sc,jm,Am,Ic,qc,km,Em,O,Ut,Nc,xm,Pm,Mc,Dm,Tm,zm,Rt,Uc,Cm,Om,oo,Lm,Sm,Im,Gt,Rc,qm,Nm,Gc,Mm,Um,Rm,Vt,Vc,Gm,Vm,Wc,Wm,Fm,Hm,Wt,Fc,Ym,Bm,Hc,Jm,Km,Qm,Ft,Yc,Xm,Zm,Bc,eh,th,ah,Ht,Jc,rh,sh,Kc,oh,ch,lh,Yt,Qc,nh,ph,co,ih,dh,mh,Bt,Xc,hh,fh,Zc,uh,gh,_h,Jt,el,$h,vh,tl,bh,wh,yh,ue,xr,jh,al,Ah,kh,Kt,Eh,ge,Pr,xh,rl,Ph,Dh,Qt,Th,K,Dr,zh,ot,Ch,sl,Oh,Lh,ol,Sh,Ih,qh,Tr,Nh,cl,Mh,Uh,Rh,Xt,Gh,_e,zr,Vh,Cr,Wh,ll,Fh,Hh,Yh,Zt,Bh,$e,Or,Jh,Lr,Kh,nl,Qh,Xh,Zh,ea,ef,ve,Sr,tf,Ir,af,pl,rf,sf,of,ta,cf,be,qr,lf,il,nf,pf,aa,df,Q,Nr,mf,Mr,hf,dl,ff,uf,gf,ml,_f,$f,ra,vf,we,Ur,bf,Rr,wf,hl,yf,jf,Af,sa,kf,ye,Gr,Ef,Vr,xf,lo,Pf,Df,Tf,oa,zf,je,Wr,Cf,ie,Of,fl,Lf,Sf,ul,If,qf,gl,Nf,Mf,Uf,ca,Rf,W,Fr,Gf,Hr,Vf,_l,Wf,Ff,Hf,la,Yf,na,Bf,pa,Jf,X,Yr,Kf,$l,Qf,Xf,ia,Zf,da,eu,Z,Br,tu,vl,au,ru,bl,su,ou,ma,cu,ee,Jr,lu,wl,nu,pu,yl,iu,du,ha,mu,te,Kr,hu,Qr,fu,jl,uu,gu,_u,Xr,$u,Al,vu,bu,wu,fa,yu,Ae,Zr,ju,es,Au,kl,ku,Eu,xu,ua,Pu,ke,ts,Du,as,Tu,El,zu,Cu,Ou,ga,Lu,Ee,rs,Su,ss,Iu,xl,qu,Nu,Mu,_a,Uu,xe,os,Ru,cs,Gu,Pl,Vu,Wu,Fu,$a,Hu,Pe,ls,Yu,ns,Bu,Dl,Ju,Ku,Qu,va,Xu,De,ps,Zu,Tl,eg,tg,ba,ag,ae,is,rg,ds,sg,zl,og,cg,lg,wa,ng,ya,pg,Te,ms,ig,hs,dg,no,mg,hg,fg,ja,ug,ze,fs,gg,us,_g,po,$g,vg,bg,Aa,wg,Ce,gs,yg,_s,jg,io,Ag,kg,Eg,ka,xg,Oe,$s,Pg,vs,Dg,mo,Tg,zg,Cg,Ea,Og,Le,bs,Lg,ws,Sg,Cl,Ig,qg,Ng,xa,Mg,re,ys,Ug,ct,Rg,Ol,Gg,Vg,Ll,Wg,Fg,Hg,Sl,Yg,Bg,Pa,Jg,F,js,Kg,de,Qg,Il,Xg,Zg,ql,e_,t_,Nl,a_,r_,s_,Ml,o_,c_,Da,l_,Ta,n_,M,As,p_,lt,i_,Ul,d_,m_,ho,h_,f_,u_,Rl,g_,__,Gl,Vl,$_,v_,V,b_,Wl,w_,y_,Fl,j_,A_,Hl,k_,E_,Yl,x_,P_,fo,D_,T_,z_,za,C_,U,ks,O_,nt,L_,Bl,S_,I_,uo,q_,N_,M_,Jl,U_,R_,Kl,Ql,G_,V_,I,W_,Xl,F_,H_,Zl,Y_,B_,en,J_,K_,tn,Q_,X_,an,Z_,e$,rn,t$,a$,go,r$,s$,o$,Ca,c$,Se,Es,l$,xs,n$,sn,p$,i$,d$,Oa,m$,R,Ps,h$,on,f$,u$,N,g$,cn,_$,$$,ln,v$,b$,nn,w$,y$,pn,j$,A$,dn,k$,E$,mn,x$,P$,D$,Ds,T$,hn,z$,C$,O$,La,L$,Sa,S$,Ie,Ts,I$,pt,q$,fn,N$,M$,un,U$,R$,G$,Ia,V$,se,zs,W$,gn,F$,H$,qa,Y$,Na,B$,_n,J$,K$,Q$,Ma,X$,$n,Z$,ev,tv,Ua,av,qe,Cs,rv,it,sv,vn,ov,cv,_o,lv,nv,pv,Ra,iv,Ne,Os,dv,bn,mv,hv,Ga,Yp;return t=new B({}),rr=new B({}),gt=new Re({props:{$$slots:{default:[Z1]},$$scope:{ctx:E}}}),$t=new Re({props:{warning:!0,$$slots:{default:[e2]},$$scope:{ctx:E}}}),or=new B({}),cr=new B({}),lr=new D({props:{code:`- print("My thing I want to print!")
+ accelerator.print("My thing I want to print!")`,highlighted:`<span class="hljs-deletion">- print(&quot;My thing I want to print!&quot;)</span>
<span class="hljs-addition">+ accelerator.print(&quot;My thing I want to print!&quot;)</span>`}}),nr=new B({}),pr=new B({}),ir=new D({props:{code:`if accelerator.is_local_main_process:
    do_thing_once_per_server()`,highlighted:`<span class="hljs-keyword">if</span> accelerator.is_local_main_process:
    do_thing_once_per_server()`}}),dr=new D({props:{code:`@accelerator.on_local_main_process
def do_my_thing():
    "Something done once per server"
    do_thing_once_per_server()`,highlighted:`<span class="hljs-meta">@accelerator.on_local_main_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done once per server&quot;</span>
    do_thing_once_per_server()`}}),mr=new B({}),hr=new D({props:{code:`if accelerator.is_main_process:
    do_thing_once()`,highlighted:`<span class="hljs-keyword">if</span> accelerator.is_main_process:
    do_thing_once()`}}),fr=new D({props:{code:`@accelerator.on_main_process
def do_my_thing():
    "Something done once per server"
    do_thing_once()`,highlighted:`<span class="hljs-meta">@accelerator.on_main_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done once per server&quot;</span>
    do_thing_once()`}}),ur=new B({}),gr=new D({props:{code:`@accelerator.on_local_process(local_process_idx=0)
def do_my_thing():
    "Something done on process index 0 on each server"
    do_thing_on_index_zero_on_each_server()`,highlighted:`<span class="hljs-meta">@accelerator.on_local_process(<span class="hljs-params">local_process_idx=<span class="hljs-number">0</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done on process index 0 on each server&quot;</span>
    do_thing_on_index_zero_on_each_server()`}}),_r=new D({props:{code:`@accelerator.on_process(process_index=0)
def do_my_thing():
    "Something done on process index 0"
    do_thing_on_index_zero()`,highlighted:`<span class="hljs-meta">@accelerator.on_process(<span class="hljs-params">process_index=<span class="hljs-number">0</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done on process index 0&quot;</span>
    do_thing_on_index_zero()`}}),$r=new B({}),vr=new B({}),br=new D({props:{code:`model = MyModel()
model = accelerator.prepare(model)
# Unwrap
model = accelerator.unwrap_model(model)`,highlighted:`model = MyModel()
model = accelerator.prepare(model)
<span class="hljs-comment"># Unwrap</span>
model = accelerator.unwrap_model(model)`}}),wr=new D({props:{code:`  state_dict = model.state_dict()
- torch.save(state_dict, "my_state.pkl")
+ accelerator.save(state_dict, "my_state.pkl")`,highlighted:`  state_dict = model.state_dict()
<span class="hljs-deletion">- torch.save(state_dict, &quot;my_state.pkl&quot;)</span>
<span class="hljs-addition">+ accelerator.save(state_dict, &quot;my_state.pkl&quot;)</span>`}}),yr=new B({}),jr=new B({}),Ar=new D({props:{code:`- accelerator = Accelerator()
+ accelerator = Accelerator(gradient_accumulation_steps=2)

  for (input, label) in training_dataloader:
+     with accelerator.accumulate(model):
          predictions = model(input)
          loss = loss_function(predictions, labels)
          accelerator.backward(loss)
          optimizer.step()
          scheduler.step()
          optimizer.zero_grad()`,highlighted:`<span class="hljs-deletion">- accelerator = Accelerator()</span>
<span class="hljs-addition">+ accelerator = Accelerator(gradient_accumulation_steps=2)</span>

  for (input, label) in training_dataloader:
<span class="hljs-addition">+     with accelerator.accumulate(model):</span>
          predictions = model(input)
          loss = loss_function(predictions, labels)
          accelerator.backward(loss)
          optimizer.step()
          scheduler.step()
          optimizer.zero_grad()`}}),kr=new B({}),Er=new T({props:{name:"class accelerate.Accelerator",anchor:"accelerate.Accelerator",parameters:[{name:"device_placement",val:": bool = True"},{name:"split_batches",val:": bool = False"},{name:"mixed_precision",val:": typing.Union[accelerate.utils.dataclasses.PrecisionType, str] = None"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"cpu",val:": bool = False"},{name:"deepspeed_plugin",val:": DeepSpeedPlugin = None"},{name:"fsdp_plugin",val:": FullyShardedDataParallelPlugin = None"},{name:"megatron_lm_plugin",val:": MegatronLMPlugin = None"},{name:"rng_types",val:": typing.Union[typing.List[typing.Union[str, accelerate.utils.dataclasses.RNGType]], NoneType] = None"},{name:"log_with",val:": typing.Union[typing.List[typing.Union[str, accelerate.utils.dataclasses.LoggerType, accelerate.tracking.GeneralTracker]], NoneType] = None"},{name:"project_dir",val:": typing.Union[str, os.PathLike, NoneType] = None"},{name:"project_config",val:": typing.Optional[accelerate.utils.dataclasses.ProjectConfiguration] = None"},{name:"logging_dir",val:": typing.Union[str, os.PathLike, NoneType] = None"},{name:"dispatch_batches",val:": typing.Optional[bool] = None"},{name:"even_batches",val:": bool = True"},{name:"step_scheduler_with_optimizer",val:": bool = True"},{name:"kwargs_handlers",val:": typing.Optional[typing.List[accelerate.utils.dataclasses.KwargsHandler]] = None"},{name:"dynamo_backend",val:": typing.Union[accelerate.utils.dataclasses.DynamoBackend, str] = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the accelerator should put objects on device (tensors yielded by the dataloader, model,
etc&#x2026;).`,name:"device_placement"},{anchor:"accelerate.Accelerator.split_batches",description:`<strong>split_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the accelerator should split the batches yielded by the dataloaders across the devices. If
<code>True</code> the actual batch size used will be the same on any kind of distributed processes, but it must be a
round multiple of the <code>num_processes</code> you are using. If <code>False</code>, actual batch size used will be the one set
in your script multiplied by the number of processes.`,name:"split_batches"},{anchor:"accelerate.Accelerator.mixed_precision",description:`<strong>mixed_precision</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Whether or not to use mixed precision training. Choose from &#x2018;no&#x2019;,&#x2018;fp16&#x2019;,&#x2018;bf16 or &#x2018;fp8&#x2019;. Will default to the
value in the environment variable <code>ACCELERATE_MIXED_PRECISION</code>, which will use the default value in the
accelerate config of the current system or the flag passed with the <code>accelerate.launch</code> command. &#x2018;fp16&#x2019;
requires pytorch 1.6 or higher. &#x2018;bf16&#x2019; requires pytorch 1.10 or higher. &#x2018;fp8&#x2019; requires the installation of
transformers-engine.`,name:"mixed_precision"},{anchor:"accelerate.Accelerator.gradient_accumulation_steps",description:`<strong>gradient_accumulation_steps</strong> (<code>int</code>, <em>optional</em>, default to 1) &#x2014;
The number of steps that should pass before gradients are accumulated. A number &gt; 1 should be combined with
<code>Accelerator.accumulate</code>. If not passed, will default to the value in the environment variable
<code>ACCELERATE_GRADIENT_ACCUMULATION_STEPS</code>.`,name:"gradient_accumulation_steps"},{anchor:"accelerate.Accelerator.cpu",description:`<strong>cpu</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to force the script to execute on CPU. Will ignore GPU available if set to <code>True</code> and force
the execution on one process only.`,name:"cpu"},{anchor:"accelerate.Accelerator.deepspeed_plugin",description:`<strong>deepspeed_plugin</strong> (<code>DeepSpeedPlugin</code>, <em>optional</em>) &#x2014;
Tweak your DeepSpeed related args using this argument. This argument is optional and can be configured
directly using <em>accelerate config</em>`,name:"deepspeed_plugin"},{anchor:"accelerate.Accelerator.fsdp_plugin",description:`<strong>fsdp_plugin</strong> (<code>FullyShardedDataParallelPlugin</code>, <em>optional</em>) &#x2014;
Tweak your FSDP related args using this argument. This argument is optional and can be configured directly
using <em>accelerate config</em>`,name:"fsdp_plugin"},{anchor:"accelerate.Accelerator.megatron_lm_plugin",description:`<strong>megatron_lm_plugin</strong> (<code>MegatronLMPlugin</code>, <em>optional</em>) &#x2014;
Tweak your MegatronLM related args using this argument. This argument is optional and can be configured
directly using <em>accelerate config</em>`,name:"megatron_lm_plugin"},{anchor:"accelerate.Accelerator.rng_types",description:`<strong>rng_types</strong> (list of <code>str</code> or <code>RNGType</code>) &#x2014;
The list of random number generators to synchronize at the beginning of each iteration in your prepared
dataloaders. Should be one or several of:</p>
<ul>
<li><code>&quot;torch&quot;</code>: the base torch random number generator</li>
<li><code>&quot;cuda&quot;</code>: the CUDA random number generator (GPU only)</li>
<li><code>&quot;xla&quot;</code>: the XLA random number generator (TPU only)</li>
<li><code>&quot;generator&quot;</code>: the <code>torch.Generator</code> of the sampler (or batch sampler if there is no sampler in your
dataloader) or of the iterable dataset (if it exists) if the underlying dataset is of that type.</li>
</ul>
<p>Will default to <code>[&quot;torch&quot;]</code> for PyTorch versions &lt;=1.5.1 and <code>[&quot;generator&quot;]</code> for PyTorch versions &gt;= 1.6.`,name:"rng_types"},{anchor:"accelerate.Accelerator.log_with",description:`<strong>log_with</strong> (list of <code>str</code>, <a href="/docs/accelerate/v0.17.1/en/package_reference/utilities#accelerate.utils.LoggerType">LoggerType</a> or <a href="/docs/accelerate/v0.17.1/en/package_reference/tracking#accelerate.tracking.GeneralTracker">GeneralTracker</a>, <em>optional</em>) &#x2014;
A list of loggers to be setup for experiment tracking. Should be one or several of:</p>
<ul>
<li><code>&quot;all&quot;</code></li>
<li><code>&quot;tensorboard&quot;</code></li>
<li><code>&quot;wandb&quot;</code></li>
<li><code>&quot;comet_ml&quot;</code>
If <code>&quot;all&quot;</code> is selected, will pick up all available trackers in the environment and initialize them. Can
also accept implementations of <code>GeneralTracker</code> for custom trackers, and can be combined with <code>&quot;all&quot;</code>.</li>
</ul>`,name:"log_with"},{anchor:"accelerate.Accelerator.project_config",description:`<strong>project_config</strong> (<code>ProjectConfiguration</code>, <em>optional</em>) &#x2014;
A configuration for how saving the state can be handled.`,name:"project_config"},{anchor:"accelerate.Accelerator.project_dir",description:`<strong>project_dir</strong> (<code>str</code>, <code>os.PathLike</code>, <em>optional</em>) &#x2014;
A path to a directory for storing data such as logs of locally-compatible loggers and potentially saved
checkpoints.`,name:"project_dir"},{anchor:"accelerate.Accelerator.dispatch_batches",description:`<strong>dispatch_batches</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, the dataloader prepared by the Accelerator is only iterated through on the main process
and then the batches are split and broadcast to each process. Will default to <code>True</code> for <code>DataLoader</code> whose
underlying dataset is an <code>IterableDataset</code>, <code>False</code> otherwise.`,name:"dispatch_batches"},{anchor:"accelerate.Accelerator.even_batches",description:`<strong>even_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If set to <code>True</code>, in cases where the total batch size across all processes does not exactly divide the
dataset, samples at the start of the dataset will be duplicated so the batch can be divided equally among
all workers.`,name:"even_batches"},{anchor:"accelerate.Accelerator.step_scheduler_with_optimizer",description:"<strong>step_scheduler_with_optimizer</strong> (<code>bool</code>, *optional<code>, defaults to </code>True<code>) -- Set </code>True<code>if the learning rate scheduler is stepped at the same time as the optimizer,</code>False` if only\ndone under certain circumstances (at the end of each epoch, for instance).",name:"step_scheduler_with_optimizer"},{anchor:"accelerate.Accelerator.kwargs_handlers",description:`<strong>kwargs_handlers</strong> (<code>List[KwargHandler]</code>, <em>optional</em>) &#x2014;
A list of <code>KwargHandler</code> to customize how the objects related to distributed training or mixed precision
are created. See <a href="kwargs">kwargs</a> for more information.`,name:"kwargs_handlers"},{anchor:"accelerate.Accelerator.dynamo_backend",description:`<strong>dynamo_backend</strong> (<code>str</code> or <code>DynamoBackend</code>, <em>optional</em>, defaults to <code>&quot;no&quot;</code>) &#x2014;
Set to one of the possible dynamo backends to optimize your training with torch dynamo.`,name:"dynamo_backend"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L123"}}),xr=new T({props:{name:"accumulate",anchor:"accelerate.Accelerator.accumulate",parameters:[{name:"model",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.accumulate.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
PyTorch Module that was prepared with <code>Accelerator.prepare</code>`,name:"model"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L806"}}),Kt=new z({props:{anchor:"accelerate.Accelerator.accumulate.example",$$slots:{default:[t2]},$$scope:{ctx:E}}}),Pr=new T({props:{name:"autocast",anchor:"accelerate.Accelerator.autocast",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L2519"}}),Qt=new z({props:{anchor:"accelerate.Accelerator.autocast.example",$$slots:{default:[a2]},$$scope:{ctx:E}}}),Dr=new T({props:{name:"backward",anchor:"accelerate.Accelerator.backward",parameters:[{name:"loss",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1608"}}),Xt=new z({props:{anchor:"accelerate.Accelerator.backward.example",$$slots:{default:[r2]},$$scope:{ctx:E}}}),zr=new T({props:{name:"clear",anchor:"accelerate.Accelerator.clear",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L2387"}}),Zt=new z({props:{anchor:"accelerate.Accelerator.clear.example",$$slots:{default:[s2]},$$scope:{ctx:E}}}),Or=new T({props:{name:"clip_grad_norm_",anchor:"accelerate.Accelerator.clip_grad_norm_",parameters:[{name:"parameters",val:""},{name:"max_norm",val:""},{name:"norm_type",val:" = 2"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1673",returnDescription:`
<p>Total norm of the parameter gradients (viewed as a single vector).</p>
`,returnType:`
<p><code>torch.Tensor</code></p>
`}}),ea=new z({props:{anchor:"accelerate.Accelerator.clip_grad_norm_.example",$$slots:{default:[o2]},$$scope:{ctx:E}}}),Sr=new T({props:{name:"clip_grad_value_",anchor:"accelerate.Accelerator.clip_grad_value_",parameters:[{name:"parameters",val:""},{name:"clip_value",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1711"}}),ta=new z({props:{anchor:"accelerate.Accelerator.clip_grad_value_.example",$$slots:{default:[c2]},$$scope:{ctx:E}}}),qr=new T({props:{name:"free_memory",anchor:"accelerate.Accelerator.free_memory",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L2363"}}),aa=new z({props:{anchor:"accelerate.Accelerator.free_memory.example",$$slots:{default:[l2]},$$scope:{ctx:E}}}),Nr=new T({props:{name:"gather",anchor:"accelerate.Accelerator.gather",parameters:[{name:"tensor",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.gather.tensor",description:`<strong>tensor</strong> (<code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code>) &#x2014;
The tensors to gather across all processes.`,name:"tensor"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1738",returnDescription:`
<p>The gathered tensor(s). Note that the
first dimension of the result is <em>num_processes</em> multiplied by the first dimension of the input tensors.</p>
`,returnType:`
<p><code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code></p>
`}}),ra=new z({props:{anchor:"accelerate.Accelerator.gather.example",$$slots:{default:[n2]},$$scope:{ctx:E}}}),Ur=new T({props:{name:"gather_for_metrics",anchor:"accelerate.Accelerator.gather_for_metrics",parameters:[{name:"tensor",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.gather_for_metrics.tensor",description:`<strong>tensor</strong> (<code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code>) &#x2014;
The tensors for calculating metrics across all processes.`,name:"tensor"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1770"}}),sa=new z({props:{anchor:"accelerate.Accelerator.gather_for_metrics.example",$$slots:{default:[p2]},$$scope:{ctx:E}}}),Gr=new T({props:{name:"get_state_dict",anchor:"accelerate.Accelerator.get_state_dict",parameters:[{name:"model",val:""},{name:"unwrap",val:" = True"}],parametersDescription:[{anchor:"accelerate.Accelerator.get_state_dict.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
A PyTorch model sent through <a href="/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.prepare">Accelerator.prepare()</a>`,name:"model"},{anchor:"accelerate.Accelerator.get_state_dict.unwrap",description:`<strong>unwrap</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to return the original underlying state_dict of <code>model</code> or to return the wrapped state_dict`,name:"unwrap"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L2431",returnDescription:`
<p>The state dictionary of the model potentially without full precision.</p>
`,returnType:`
<p><code>dict</code></p>
`}}),oa=new z({props:{anchor:"accelerate.Accelerator.get_state_dict.example",$$slots:{default:[i2]},$$scope:{ctx:E}}}),Wr=new T({props:{name:"get_tracker",anchor:"accelerate.Accelerator.get_tracker",parameters:[{name:"name",val:": str"},{name:"unwrap",val:": bool = False"}],parametersDescription:[{anchor:"accelerate.Accelerator.get_tracker.name",description:`<strong>name</strong> (<code>str</code>) &#x2014;
The name of a tracker, corresponding to the <code>.name</code> property.`,name:"name"},{anchor:"accelerate.Accelerator.get_tracker.unwrap",description:`<strong>unwrap</strong> (<code>bool</code>) &#x2014;
Whether to return the internal tracking mechanism or to return the wrapped tracker instead
(recommended).`,name:"unwrap"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1992",returnDescription:`
<p>The tracker corresponding to <code>name</code> if it exists.</p>
`,returnType:`
<p><code>GeneralTracker</code></p>
`}}),ca=new z({props:{anchor:"accelerate.Accelerator.get_tracker.example",$$slots:{default:[d2]},$$scope:{ctx:E}}}),Fr=new T({props:{name:"join_uneven_inputs",anchor:"accelerate.Accelerator.join_uneven_inputs",parameters:[{name:"joinables",val:""},{name:"even_batches",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.join_uneven_inputs.joinables",description:`<strong>joinables</strong> (<code>List[torch.distributed.algorithms.Joinable]</code>) &#x2014;
A list of models or optimizers that subclass <code>torch.distributed.algorithms.Joinable</code>. Most commonly, a
PyTorch Module that was prepared with <code>Accelerator.prepare</code> for DistributedDataParallel training.`,name:"joinables"},{anchor:"accelerate.Accelerator.join_uneven_inputs.even_batches",description:`<strong>even_batches</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set, this will override the value of <code>even_batches</code> set in the <code>Accelerator</code>. If it is not provided,
the default <code>Accelerator</code> value wil be used.`,name:"even_batches"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L842"}}),la=new Re({props:{warning:!0,$$slots:{default:[m2]},$$scope:{ctx:E}}}),na=new Re({props:{warning:!0,$$slots:{default:[h2]},$$scope:{ctx:E}}}),pa=new z({props:{anchor:"accelerate.Accelerator.join_uneven_inputs.example",$$slots:{default:[f2]},$$scope:{ctx:E}}}),Yr=new T({props:{name:"load_state",anchor:"accelerate.Accelerator.load_state",parameters:[{name:"input_dir",val:": str"},{name:"**load_model_func_kwargs",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.load_state.input_dir",description:`<strong>input_dir</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
The name of the folder all relevant weights and states were saved in.`,name:"input_dir"},{anchor:"accelerate.Accelerator.load_state.load_model_func_kwargs",description:`<strong>load_model_func_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Additional keyword arguments for loading model which can be passed to the underlying load function,
such as optional arguments for DeepSpeed&#x2019;s <code>load_checkpoint</code> function.`,name:"load_model_func_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L2271"}}),ia=new Re({props:{$$slots:{default:[u2]},$$scope:{ctx:E}}}),da=new z({props:{anchor:"accelerate.Accelerator.load_state.example",$$slots:{default:[g2]},$$scope:{ctx:E}}}),Br=new T({props:{name:"local_main_process_first",anchor:"accelerate.Accelerator.local_main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L731"}}),ma=new z({props:{anchor:"accelerate.Accelerator.local_main_process_first.example",$$slots:{default:[_2]},$$scope:{ctx:E}}}),Jr=new T({props:{name:"main_process_first",anchor:"accelerate.Accelerator.main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L710"}}),ha=new z({props:{anchor:"accelerate.Accelerator.main_process_first.example",$$slots:{default:[$2]},$$scope:{ctx:E}}}),Kr=new T({props:{name:"no_sync",anchor:"accelerate.Accelerator.no_sync",parameters:[{name:"model",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.no_sync.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
PyTorch Module that was prepared with <code>Accelerator.prepare</code>`,name:"model"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L752"}}),fa=new z({props:{anchor:"accelerate.Accelerator.no_sync.example",$$slots:{default:[v2]},$$scope:{ctx:E}}}),Zr=new T({props:{name:"on_last_process",anchor:"accelerate.Accelerator.on_last_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any]"}],parametersDescription:[{anchor:"accelerate.Accelerator.on_last_process.function",description:"<strong>function</strong> (<code>Callable</code>) &#x2014; The function to decorate.",name:"function"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L578"}}),ua=new z({props:{anchor:"accelerate.Accelerator.on_last_process.example",$$slots:{default:[b2]},$$scope:{ctx:E}}}),ts=new T({props:{name:"on_local_main_process",anchor:"accelerate.Accelerator.on_local_main_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.on_local_main_process.function",description:"<strong>function</strong> (<code>Callable</code>) &#x2014; The function to decorate.",name:"function"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L536"}}),ga=new z({props:{anchor:"accelerate.Accelerator.on_local_main_process.example",$$slots:{default:[w2]},$$scope:{ctx:E}}}),rs=new T({props:{name:"on_local_process",anchor:"accelerate.Accelerator.on_local_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"},{name:"local_process_index",val:": int = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.on_local_process.function",description:`<strong>function</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
The function to decorate.`,name:"function"},{anchor:"accelerate.Accelerator.on_local_process.local_process_index",description:`<strong>local_process_index</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The index of the local process on which to run the function.`,name:"local_process_index"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L662"}}),_a=new z({props:{anchor:"accelerate.Accelerator.on_local_process.example",$$slots:{default:[y2]},$$scope:{ctx:E}}}),os=new T({props:{name:"on_main_process",anchor:"accelerate.Accelerator.on_main_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.on_main_process.function",description:"<strong>function</strong> (<code>Callable</code>) &#x2014; The function to decorate.",name:"function"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L497"}}),$a=new z({props:{anchor:"accelerate.Accelerator.on_main_process.example",$$slots:{default:[j2]},$$scope:{ctx:E}}}),ls=new T({props:{name:"on_process",anchor:"accelerate.Accelerator.on_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"},{name:"process_index",val:": int = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.on_process.function",description:`<strong>function</strong> (<code>Callable</code>, <code>optional</code>) &#x2014;
The function to decorate.`,name:"function"},{anchor:"accelerate.Accelerator.on_process.process_index",description:`<strong>process_index</strong> (<code>int</code>, <code>optional</code>) &#x2014;
The index of the process on which to run the function.`,name:"process_index"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L617"}}),va=new z({props:{anchor:"accelerate.Accelerator.on_process.example",$$slots:{default:[A2]},$$scope:{ctx:E}}}),ps=new T({props:{name:"pad_across_processes",anchor:"accelerate.Accelerator.pad_across_processes",parameters:[{name:"tensor",val:""},{name:"dim",val:" = 0"},{name:"pad_index",val:" = 0"},{name:"pad_first",val:" = False"}],parametersDescription:[{anchor:"accelerate.Accelerator.pad_across_processes.tensor",description:`<strong>tensor</strong> (nested list/tuple/dictionary of <code>torch.Tensor</code>) &#x2014;
The data to gather.`,name:"tensor"},{anchor:"accelerate.Accelerator.pad_across_processes.dim",description:`<strong>dim</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The dimension on which to pad.`,name:"dim"},{anchor:"accelerate.Accelerator.pad_across_processes.pad_index",description:`<strong>pad_index</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The value with which to pad.`,name:"pad_index"},{anchor:"accelerate.Accelerator.pad_across_processes.pad_first",description:`<strong>pad_first</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to pad at the beginning or the end.`,name:"pad_first"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1852",returnDescription:`
<p>The padded tensor(s).</p>
`,returnType:`
<p><code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code></p>
`}}),ba=new z({props:{anchor:"accelerate.Accelerator.pad_across_processes.example",$$slots:{default:[k2]},$$scope:{ctx:E}}}),is=new T({props:{name:"prepare",anchor:"accelerate.Accelerator.prepare",parameters:[{name:"*args",val:""},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare.*args",description:`<strong>*args</strong> (list of objects) &#x2014;
Any of the following type of objects:</p>
<ul>
<li><code>torch.utils.data.DataLoader</code>: PyTorch Dataloader</li>
<li><code>torch.nn.Module</code>: PyTorch Module</li>
<li><code>torch.optim.Optimizer</code>: PyTorch Optimizer</li>
<li><code>torch.optim.lr_scheduler.LRScheduler</code>: PyTorch LR Scheduler</li>
</ul>`,name:"*args"},{anchor:"accelerate.Accelerator.prepare.device_placement",description:`<strong>device_placement</strong> (<code>List[bool]</code>, <em>optional</em>) &#x2014;
Used to customize whether automatic device placement should be performed for each object passed. Needs
to be a list of the same length as <code>args</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1006"}}),wa=new Re({props:{$$slots:{default:[E2]},$$scope:{ctx:E}}}),ya=new z({props:{anchor:"accelerate.Accelerator.prepare.example",$$slots:{default:[x2]},$$scope:{ctx:E}}}),ms=new T({props:{name:"prepare_data_loader",anchor:"accelerate.Accelerator.prepare_data_loader",parameters:[{name:"data_loader",val:": DataLoader"},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_data_loader.data_loader",description:`<strong>data_loader</strong> (<code>torch.utils.data.DataLoader</code>) &#x2014;
A vanilla PyTorch DataLoader to prepare`,name:"data_loader"},{anchor:"accelerate.Accelerator.prepare_data_loader.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to place the batches on the proper device in the prepared dataloader. Will default to
<code>self.device_placement</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1505"}}),ja=new z({props:{anchor:"accelerate.Accelerator.prepare_data_loader.example",$$slots:{default:[P2]},$$scope:{ctx:E}}}),fs=new T({props:{name:"prepare_model",anchor:"accelerate.Accelerator.prepare_model",parameters:[{name:"model",val:": Module"},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_model.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
A PyTorch model to prepare. You don&#x2019;t need to prepare a model if it is used only for inference without
any kind of mixed precision`,name:"model"},{anchor:"accelerate.Accelerator.prepare_model.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to place the model on the proper device. Will default to <code>self.device_placement</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1114"}}),Aa=new z({props:{anchor:"accelerate.Accelerator.prepare_model.example",$$slots:{default:[D2]},$$scope:{ctx:E}}}),gs=new T({props:{name:"prepare_optimizer",anchor:"accelerate.Accelerator.prepare_optimizer",parameters:[{name:"optimizer",val:": Optimizer"},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_optimizer.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.Optimizer</code>) &#x2014;
A vanilla PyTorch optimizer to prepare`,name:"optimizer"},{anchor:"accelerate.Accelerator.prepare_optimizer.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to place the optimizer on the proper device. Will default to <code>self.device_placement</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1544"}}),ka=new z({props:{anchor:"accelerate.Accelerator.prepare_optimizer.example",$$slots:{default:[T2]},$$scope:{ctx:E}}}),$s=new T({props:{name:"prepare_scheduler",anchor:"accelerate.Accelerator.prepare_scheduler",parameters:[{name:"scheduler",val:": _LRScheduler"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_scheduler.scheduler",description:`<strong>scheduler</strong> (<code>torch.optim.lr_scheduler.LRScheduler</code>) &#x2014;
A vanilla PyTorch scheduler to prepare`,name:"scheduler"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1572"}}),Ea=new z({props:{anchor:"accelerate.Accelerator.prepare_scheduler.example",$$slots:{default:[z2]},$$scope:{ctx:E}}}),bs=new T({props:{name:"print",anchor:"accelerate.Accelerator.print",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L928"}}),xa=new z({props:{anchor:"accelerate.Accelerator.print.example",$$slots:{default:[C2]},$$scope:{ctx:E}}}),ys=new T({props:{name:"reduce",anchor:"accelerate.Accelerator.reduce",parameters:[{name:"tensor",val:""},{name:"reduction",val:" = 'sum'"}],parametersDescription:[{anchor:"accelerate.Accelerator.reduce.tensor",description:`<strong>tensor</strong> (<code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code>) &#x2014;
The tensors to reduce across all processes.`,name:"tensor"},{anchor:"accelerate.Accelerator.reduce.reduction",description:`<strong>reduction</strong> (<code>str</code>, <em>optional</em>, defaults to &#x201C;sum&#x201D;) &#x2014;
A reduction type, can be one of &#x2018;sum&#x2019;, &#x2018;mean&#x2019;, or &#x2018;none&#x2019;. If &#x2018;none&#x2019;, will not perform any operation.`,name:"reduction"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1818",returnDescription:`
<p>The reduced tensor(s).</p>
`,returnType:`
<p><code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code></p>
`}}),Pa=new z({props:{anchor:"accelerate.Accelerator.reduce.example",$$slots:{default:[O2]},$$scope:{ctx:E}}}),js=new T({props:{name:"register_for_checkpointing",anchor:"accelerate.Accelerator.register_for_checkpointing",parameters:[{name:"*objects",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L2483"}}),Da=new Re({props:{$$slots:{default:[L2]},$$scope:{ctx:E}}}),Ta=new z({props:{anchor:"accelerate.Accelerator.register_for_checkpointing.example",$$slots:{default:[S2]},$$scope:{ctx:E}}}),As=new T({props:{name:"register_load_state_pre_hook",anchor:"accelerate.Accelerator.register_load_state_pre_hook",parameters:[{name:"hook",val:": typing.Callable[..., NoneType]"}],parametersDescription:[{anchor:"accelerate.Accelerator.register_load_state_pre_hook.hook",description:`<strong>hook</strong> (<code>Callable</code>) &#x2014;
A function to be called in <a href="/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.load_state">Accelerator.load_state()</a> before <code>load_checkpoint</code>.`,name:"hook"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L2240",returnDescription:`
<p>a handle that can be used to remove the added hook by calling
<code>handle.remove()</code></p>
`,returnType:`
<p><code>torch.utils.hooks.RemovableHandle</code></p>
`}}),za=new Re({props:{$$slots:{default:[I2]},$$scope:{ctx:E}}}),ks=new T({props:{name:"register_save_state_pre_hook",anchor:"accelerate.Accelerator.register_save_state_pre_hook",parameters:[{name:"hook",val:": typing.Callable[..., NoneType]"}],parametersDescription:[{anchor:"accelerate.Accelerator.register_save_state_pre_hook.hook",description:`<strong>hook</strong> (<code>Callable</code>) &#x2014;
A function to be called in <a href="/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.save_state">Accelerator.save_state()</a> before <code>save_checkpoint</code>.`,name:"hook"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L2094",returnDescription:`
<p>a handle that can be used to remove the added hook by calling
<code>handle.remove()</code></p>
`,returnType:`
<p><code>torch.utils.hooks.RemovableHandle</code></p>
`}}),Ca=new Re({props:{$$slots:{default:[q2]},$$scope:{ctx:E}}}),Es=new T({props:{name:"save",anchor:"accelerate.Accelerator.save",parameters:[{name:"obj",val:""},{name:"f",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.save.obj",description:"<strong>obj</strong> (<code>object</code>) &#x2014; The object to save.",name:"obj"},{anchor:"accelerate.Accelerator.save.f",description:"<strong>f</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014; Where to save the content of <code>obj</code>.",name:"f"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L2074"}}),Oa=new z({props:{anchor:"accelerate.Accelerator.save.example",$$slots:{default:[N2]},$$scope:{ctx:E}}}),Ps=new T({props:{name:"save_state",anchor:"accelerate.Accelerator.save_state",parameters:[{name:"output_dir",val:": str = None"},{name:"**save_model_func_kwargs",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.save_state.output_dir",description:`<strong>output_dir</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
The name of the folder to save all relevant weights and states.`,name:"output_dir"},{anchor:"accelerate.Accelerator.save_state.save_model_func_kwargs",description:`<strong>save_model_func_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Additional keyword arguments for saving model which can be passed to the underlying save function, such
as optional arguments for DeepSpeed&#x2019;s <code>save_checkpoint</code> function.`,name:"save_model_func_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L2126"}}),La=new Re({props:{$$slots:{default:[M2]},$$scope:{ctx:E}}}),Sa=new z({props:{anchor:"accelerate.Accelerator.save_state.example",$$slots:{default:[U2]},$$scope:{ctx:E}}}),Ts=new T({props:{name:"skip_first_batches",anchor:"accelerate.Accelerator.skip_first_batches",parameters:[{name:"dataloader",val:""},{name:"num_batches",val:": int = 0"}],parametersDescription:[{anchor:"accelerate.Accelerator.skip_first_batches.dataloader",description:"<strong>dataloader</strong> (<code>torch.utils.data.DataLoader</code>) &#x2014; The data loader in which to skip batches.",name:"dataloader"},{anchor:"accelerate.Accelerator.skip_first_batches.num_batches",description:"<strong>num_batches</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014; The number of batches to skip",name:"num_batches"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L2561"}}),Ia=new z({props:{anchor:"accelerate.Accelerator.skip_first_batches.example",$$slots:{default:[R2]},$$scope:{ctx:E}}}),zs=new T({props:{name:"unscale_gradients",anchor:"accelerate.Accelerator.unscale_gradients",parameters:[{name:"optimizer",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.unscale_gradients.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.Optimizer</code> or <code>List[torch.optim.Optimizer]</code>, <em>optional</em>) &#x2014;
The optimizer(s) for which to unscale gradients. If not set, will unscale gradients on all optimizers
that were passed to <a href="/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.prepare">prepare()</a>.`,name:"optimizer"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1638"}}),Ua=new z({props:{anchor:"accelerate.Accelerator.unscale_gradients.example",$$slots:{default:[G2]},$$scope:{ctx:E}}}),Cs=new T({props:{name:"unwrap_model",anchor:"accelerate.Accelerator.unwrap_model",parameters:[{name:"model",val:""},{name:"keep_fp32_wrapper",val:": bool = True"}],parametersDescription:[{anchor:"accelerate.Accelerator.unwrap_model.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
The model to unwrap.`,name:"model"},{anchor:"accelerate.Accelerator.unwrap_model.keep_fp32_wrapper",description:`<strong>keep_fp32_wrapper</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to not remove the mixed precision hook if it was added.`,name:"keep_fp32_wrapper"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1887",returnDescription:`
<p>The unwrapped model.</p>
`,returnType:`
<p><code>torch.nn.Module</code></p>
`}}),Ra=new z({props:{anchor:"accelerate.Accelerator.unwrap_model.example",$$slots:{default:[V2]},$$scope:{ctx:E}}}),Os=new T({props:{name:"wait_for_everyone",anchor:"accelerate.Accelerator.wait_for_everyone",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.17.1/src/accelerate/accelerator.py#L1920"}}),Ga=new z({props:{anchor:"accelerate.Accelerator.wait_for_everyone.example",$$slots:{default:[W2]},$$scope:{ctx:E}}}),{c(){p=c("meta"),g=h(),m=c("h1"),i=c("a"),u=c("span"),v(t.$$.fragment),d=h(),L=c("span"),Ge=s("Accelerator"),ft=h(),J=c("p"),Ve=s("The "),q=c("a"),Ws=s("Accelerator"),Fs=s(` is the main class provided by \u{1F917} Accelerate.
It serves at the main entrypoint for the API.`),ar=h(),We=c("h2"),ut=c("a"),Ko=c("span"),v(rr.$$.fragment),Si=h(),Qo=c("span"),Ii=s("Quick adaptation of your code"),np=h(),Hs=c("p"),qi=s("To quickly adapt your script to work on any kind of setup with \u{1F917} Accelerate just:"),pp=h(),he=c("ol"),Fe=c("li"),Ni=s("Initialize an "),Ys=c("a"),Mi=s("Accelerator"),Ui=s(" object (that we will call "),Xo=c("code"),Ri=s("accelerator"),Gi=s(" throughout this page) as early as possible in your script."),Vi=h(),sr=c("li"),Wi=s("Pass your dataloader(s), model(s), optimizer(s), and scheduler(s) to the "),Bs=c("a"),Fi=s("prepare()"),Hi=s(" method."),Yi=h(),pe=c("li"),Bi=s("Remove all the "),Zo=c("code"),Ji=s(".cuda()"),Ki=s(" or "),ec=c("code"),Qi=s(".to(device)"),Xi=s(" from your code and let the "),tc=c("code"),Zi=s("accelerator"),ed=s(" handle the device placement for you."),ip=h(),v(gt.$$.fragment),dp=h(),He=c("ol"),_t=c("li"),td=s("Replace "),ac=c("code"),ad=s("loss.backward()"),rd=s(" in your code with "),rc=c("code"),sd=s("accelerator.backward(loss)"),od=h(),Js=c("li"),cd=s("Gather your predictions and labels before storing them or using them for metric computation using "),Ks=c("a"),ld=s("gather()"),mp=h(),v($t.$$.fragment),hp=h(),vt=c("p"),nd=s(`In most cases this is all that is needed. The next section lists a few more advanced use cases and nice features
you should search for and replace by the corresponding methods of your `),sc=c("code"),pd=s("accelerator"),id=s(":"),fp=h(),Ye=c("h2"),bt=c("a"),oc=c("span"),v(or.$$.fragment),dd=h(),cc=c("span"),md=s("Advanced recommendations"),up=h(),Be=c("h3"),wt=c("a"),lc=c("span"),v(cr.$$.fragment),hd=h(),nc=c("span"),fd=s("Printing"),gp=h(),Je=c("p"),pc=c("code"),ud=s("print"),gd=s(" statements should be replaced by "),Qs=c("a"),_d=s("print()"),$d=s(" to be printed once per process"),_p=h(),v(lr.$$.fragment),$p=h(),Ke=c("h3"),yt=c("a"),ic=c("span"),v(nr.$$.fragment),vd=h(),dc=c("span"),bd=s("Executing processes"),vp=h(),Qe=c("h4"),jt=c("a"),mc=c("span"),v(pr.$$.fragment),wd=h(),hc=c("span"),yd=s("Once on a single server"),bp=h(),At=c("p"),jd=s("For statements that should be executed once per server, use "),fc=c("code"),Ad=s("is_local_main_process"),kd=s(":"),wp=h(),v(ir.$$.fragment),yp=h(),kt=c("p"),Ed=s("A function can be wrapped using the "),Xs=c("a"),xd=s("on_local_main_process()"),Pd=s(` function to achieve the same
behavior on a function\u2019s execution:`),jp=h(),v(dr.$$.fragment),Ap=h(),Xe=c("h4"),Et=c("a"),uc=c("span"),v(mr.$$.fragment),Dd=h(),gc=c("span"),Td=s("Only ever once across all servers"),kp=h(),xt=c("p"),zd=s("For statements that should only ever be executed once, use "),_c=c("code"),Cd=s("is_main_process"),Od=s(":"),Ep=h(),v(hr.$$.fragment),xp=h(),Pt=c("p"),Ld=s("A function can be wrapped using the "),Zs=c("a"),Sd=s("on_main_process()"),Id=s(` function to achieve the same
behavior on a function\u2019s execution:`),Pp=h(),v(fr.$$.fragment),Dp=h(),Ze=c("h4"),Dt=c("a"),$c=c("span"),v(ur.$$.fragment),qd=h(),vc=c("span"),Nd=s("On specific processes"),Tp=h(),eo=c("p"),Md=s(`If a function should be ran on a specific overall or local process index, there are similar decorators
to achieve this:`),zp=h(),v(gr.$$.fragment),Cp=h(),v(_r.$$.fragment),Op=h(),et=c("h3"),Tt=c("a"),bc=c("span"),v($r.$$.fragment),Ud=h(),wc=c("span"),Rd=s("Synchronicity control"),Lp=h(),zt=c("p"),Gd=s("Use "),to=c("a"),Vd=s("wait_for_everyone()"),Wd=s(" to make sure all processes join that point before continuing. (Useful before a model save for instance)"),Sp=h(),tt=c("h3"),Ct=c("a"),yc=c("span"),v(vr.$$.fragment),Fd=h(),jc=c("span"),Hd=s("Saving and loading"),Ip=h(),Ot=c("p"),Yd=s("Use "),ao=c("a"),Bd=s("unwrap_model()"),Jd=s(" before saving to remove all special model wrappers added during the distributed process."),qp=h(),v(br.$$.fragment),Np=h(),fe=c("p"),Kd=s("Use "),ro=c("a"),Qd=s("save()"),Xd=s(" instead of "),Ac=c("code"),Zd=s("torch.save"),em=s(":"),Mp=h(),v(wr.$$.fragment),Up=h(),at=c("h3"),Lt=c("a"),kc=c("span"),v(yr.$$.fragment),tm=h(),Ec=c("span"),am=s("Operations"),Rp=h(),Y=c("p"),rm=s("Use "),St=c("a"),sm=s("clip"),xc=c("em"),om=s("grad_norm"),cm=s("()"),lm=s(" instead of "),Pc=c("code"),nm=s("torch.nn.utils.clip_grad_norm_"),pm=s(" and "),It=c("a"),im=s("clip"),Dc=c("em"),dm=s("grad_value"),mm=s("()"),hm=s(" instead of "),Tc=c("code"),fm=s("torch.nn.utils.clip_grad_value"),Gp=h(),rt=c("h3"),qt=c("a"),zc=c("span"),v(jr.$$.fragment),um=h(),Cc=c("span"),gm=s("Gradient Accumulation"),Vp=h(),Nt=c("p"),_m=s("To perform gradient accumulation use "),so=c("a"),$m=s("accumulate()"),vm=s(` and specify a gradient_accumulation_steps.
This will also automatically ensure the gradients are synced or unsynced when on
multi-device training, check if the step should actually be performed, and auto-scale the loss:`),Wp=h(),v(Ar.$$.fragment),Fp=h(),st=c("h2"),Mt=c("a"),Oc=c("span"),v(kr.$$.fragment),bm=h(),Lc=c("span"),wm=s("Overall API documentation:"),Hp=h(),x=c("div"),v(Er.$$.fragment),ym=h(),Sc=c("p"),jm=s("Creates an instance of an accelerator for distributed training (on multi-GPU, TPU) or mixed precision training."),Am=h(),Ic=c("p"),qc=c("strong"),km=s("Available attributes:"),Em=h(),O=c("ul"),Ut=c("li"),Nc=c("strong"),xm=s("device"),Pm=s(" ("),Mc=c("code"),Dm=s("torch.device"),Tm=s(") \u2014 The device to use."),zm=h(),Rt=c("li"),Uc=c("strong"),Cm=s("distributed_type"),Om=s(" ("),oo=c("a"),Lm=s("DistributedType"),Sm=s(") \u2014 The distributed training configuration."),Im=h(),Gt=c("li"),Rc=c("strong"),qm=s("local_process_index"),Nm=s(" ("),Gc=c("code"),Mm=s("int"),Um=s(") \u2014 The process index on the current machine."),Rm=h(),Vt=c("li"),Vc=c("strong"),Gm=s("mixed_precision"),Vm=s(" ("),Wc=c("code"),Wm=s("str"),Fm=s(") \u2014 The configured mixed precision mode."),Hm=h(),Wt=c("li"),Fc=c("strong"),Ym=s("num_processes"),Bm=s(" ("),Hc=c("code"),Jm=s("int"),Km=s(") \u2014 The total number of processes used for training."),Qm=h(),Ft=c("li"),Yc=c("strong"),Xm=s("optimizer_step_was_skipped"),Zm=s(" ("),Bc=c("code"),eh=s("bool"),th=s(`) \u2014 Whether or not the optimizer update was skipped (because of
gradient overflow in mixed precision), in which
case the learning rate should not be changed.`),ah=h(),Ht=c("li"),Jc=c("strong"),rh=s("process_index"),sh=s(" ("),Kc=c("code"),oh=s("int"),ch=s(") \u2014 The overall index of the current process among all processes."),lh=h(),Yt=c("li"),Qc=c("strong"),nh=s("state"),ph=s(" ("),co=c("a"),ih=s("AcceleratorState"),dh=s(") \u2014 The distributed setup state."),mh=h(),Bt=c("li"),Xc=c("strong"),hh=s("sync_gradients"),fh=s(" ("),Zc=c("code"),uh=s("bool"),gh=s(") \u2014 Whether the gradients are currently being synced across all processes."),_h=h(),Jt=c("li"),el=c("strong"),$h=s("use_distributed"),vh=s(" ("),tl=c("code"),bh=s("bool"),wh=s(") \u2014 Whether the current configuration is for distributed training."),yh=h(),ue=c("div"),v(xr.$$.fragment),jh=h(),al=c("p"),Ah=s("A context manager that will lightly wrap around and perform gradient accumulation automatically"),kh=h(),v(Kt.$$.fragment),Eh=h(),ge=c("div"),v(Pr.$$.fragment),xh=h(),rl=c("p"),Ph=s(`Will apply automatic mixed-precision inside the block inside this context manager, if it is enabled. Nothing
different will happen otherwise.`),Dh=h(),v(Qt.$$.fragment),Th=h(),K=c("div"),v(Dr.$$.fragment),zh=h(),ot=c("p"),Ch=s("Scales the gradients in accordance to "),sl=c("code"),Oh=s("Accelerator.gradient_accumulation_steps"),Lh=s(` and calls the correct
`),ol=c("code"),Sh=s("backward()"),Ih=s(" based on the configuration."),qh=h(),Tr=c("p"),Nh=s("Should be used in lieu of "),cl=c("code"),Mh=s("loss.backward()"),Uh=s("."),Rh=h(),v(Xt.$$.fragment),Gh=h(),_e=c("div"),v(zr.$$.fragment),Vh=h(),Cr=c("p"),Wh=s("Alias for "),ll=c("code"),Fh=s("Accelerate.free_memory"),Hh=s(`, releases all references to the internal objects stored and call the
garbage collector. You should call this method between two trainings with different models/optimizers.`),Yh=h(),v(Zt.$$.fragment),Bh=h(),$e=c("div"),v(Or.$$.fragment),Jh=h(),Lr=c("p"),Kh=s("Should be used in place of "),nl=c("code"),Qh=s("torch.nn.utils.clip_grad_norm_"),Xh=s("."),Zh=h(),v(ea.$$.fragment),ef=h(),ve=c("div"),v(Sr.$$.fragment),tf=h(),Ir=c("p"),af=s("Should be used in place of "),pl=c("code"),rf=s("torch.nn.utils.clip_grad_value_"),sf=s("."),of=h(),v(ta.$$.fragment),cf=h(),be=c("div"),v(qr.$$.fragment),lf=h(),il=c("p"),nf=s(`Will release all references to the internal objects stored and call the garbage collector. You should call this
method between two trainings with different models/optimizers.`),pf=h(),v(aa.$$.fragment),df=h(),Q=c("div"),v(Nr.$$.fragment),mf=h(),Mr=c("p"),hf=s("Gather the values in "),dl=c("em"),ff=s("tensor"),uf=s(` across all processes and concatenate them on the first dimension. Useful to
regroup the predictions from all processes when doing evaluation.`),gf=h(),ml=c("p"),_f=s(`Note:
This gather happens in all processes.`),$f=h(),v(ra.$$.fragment),vf=h(),we=c("div"),v(Ur.$$.fragment),bf=h(),Rr=c("p"),wf=s("Gathers "),hl=c("code"),yf=s("tensor"),jf=s(` and potentially drops duplicates in the last batch if on a distributed system. Should be used
for gathering the inputs and targets for metric calculation.`),Af=h(),v(sa.$$.fragment),kf=h(),ye=c("div"),v(Gr.$$.fragment),Ef=h(),Vr=c("p"),xf=s("Returns the state dictionary of a model sent through "),lo=c("a"),Pf=s("Accelerator.prepare()"),Df=s(` potentially without full
precision.`),Tf=h(),v(oa.$$.fragment),zf=h(),je=c("div"),v(Wr.$$.fragment),Cf=h(),ie=c("p"),Of=s("Returns a "),fl=c("code"),Lf=s("tracker"),Sf=s(" from "),ul=c("code"),If=s("self.trackers"),qf=s(" based on "),gl=c("code"),Nf=s("name"),Mf=s(" on the main process only."),Uf=h(),v(ca.$$.fragment),Rf=h(),W=c("div"),v(Fr.$$.fragment),Gf=h(),Hr=c("p"),Vf=s(`A context manager that facilitates distributed training or evaluation on uneven inputs, which acts as a wrapper
around `),_l=c("code"),Wf=s("torch.distributed.algorithms.join"),Ff=s(`. This is useful when the total batch size does not evenly divide the
length of the dataset.`),Hf=h(),v(la.$$.fragment),Yf=h(),v(na.$$.fragment),Bf=h(),v(pa.$$.fragment),Jf=h(),X=c("div"),v(Yr.$$.fragment),Kf=h(),$l=c("p"),Qf=s("Loads the current states of the model, optimizer, scaler, RNG generators, and registered objects."),Xf=h(),v(ia.$$.fragment),Zf=h(),v(da.$$.fragment),eu=h(),Z=c("div"),v(Br.$$.fragment),tu=h(),vl=c("p"),au=s("Lets the local main process go inside a with block."),ru=h(),bl=c("p"),su=s("The other processes will enter the with block after the main process exits."),ou=h(),v(ma.$$.fragment),cu=h(),ee=c("div"),v(Jr.$$.fragment),lu=h(),wl=c("p"),nu=s("Lets the main process go first inside a with block."),pu=h(),yl=c("p"),iu=s("The other processes will enter the with block after the main process exits."),du=h(),v(ha.$$.fragment),mu=h(),te=c("div"),v(Kr.$$.fragment),hu=h(),Qr=c("p"),fu=s(`A context manager to disable gradient synchronizations across DDP processes by calling
`),jl=c("code"),uu=s("torch.nn.parallel.DistributedDataParallel.no_sync"),gu=s("."),_u=h(),Xr=c("p"),$u=s("If "),Al=c("code"),vu=s("model"),bu=s(" is not in DDP, this context manager does nothing"),wu=h(),v(fa.$$.fragment),yu=h(),Ae=c("div"),v(Zr.$$.fragment),ju=h(),es=c("p"),Au=s(`A decorator that will run the decorated function on the last process only. Can also be called using the
`),kl=c("code"),ku=s("PartialState"),Eu=s(" class."),xu=h(),v(ua.$$.fragment),Pu=h(),ke=c("div"),v(ts.$$.fragment),Du=h(),as=c("p"),Tu=s(`A decorator that will run the decorated function on the local main process only. Can also be called using the
`),El=c("code"),zu=s("PartialState"),Cu=s(" class."),Ou=h(),v(ga.$$.fragment),Lu=h(),Ee=c("div"),v(rs.$$.fragment),Su=h(),ss=c("p"),Iu=s(`A decorator that will run the decorated function on a given local process index only. Can also be called using
the `),xl=c("code"),qu=s("PartialState"),Nu=s(" class."),Mu=h(),v(_a.$$.fragment),Uu=h(),xe=c("div"),v(os.$$.fragment),Ru=h(),cs=c("p"),Gu=s(`A decorator that will run the decorated function on the main process only. Can also be called using the
`),Pl=c("code"),Vu=s("PartialState"),Wu=s(" class."),Fu=h(),v($a.$$.fragment),Hu=h(),Pe=c("div"),v(ls.$$.fragment),Yu=h(),ns=c("p"),Bu=s(`A decorator that will run the decorated function on a given process index only. Can also be called using the
`),Dl=c("code"),Ju=s("PartialState"),Ku=s(" class."),Qu=h(),v(va.$$.fragment),Xu=h(),De=c("div"),v(ps.$$.fragment),Zu=h(),Tl=c("p"),eg=s(`Recursively pad the tensors in a nested list/tuple/dictionary of tensors from all devices to the same size so
they can safely be gathered.`),tg=h(),v(ba.$$.fragment),ag=h(),ae=c("div"),v(is.$$.fragment),rg=h(),ds=c("p"),sg=s("Prepare all objects passed in "),zl=c("code"),og=s("args"),cg=s(` for distributed training and mixed precision, then return them in the same
order.`),lg=h(),v(wa.$$.fragment),ng=h(),v(ya.$$.fragment),pg=h(),Te=c("div"),v(ms.$$.fragment),ig=h(),hs=c("p"),dg=s(`Prepares a PyTorch DataLoader for training in any distributed setup. It is recommended to use
`),no=c("a"),mg=s("Accelerator.prepare()"),hg=s(" instead."),fg=h(),v(ja.$$.fragment),ug=h(),ze=c("div"),v(fs.$$.fragment),gg=h(),us=c("p"),_g=s(`Prepares a PyTorch model for training in any distributed setup. It is recommended to use
`),po=c("a"),$g=s("Accelerator.prepare()"),vg=s(" instead."),bg=h(),v(Aa.$$.fragment),wg=h(),Ce=c("div"),v(gs.$$.fragment),yg=h(),_s=c("p"),jg=s(`Prepares a PyTorch Optimizer for training in any distributed setup. It is recommended to use
`),io=c("a"),Ag=s("Accelerator.prepare()"),kg=s(" instead."),Eg=h(),v(ka.$$.fragment),xg=h(),Oe=c("div"),v($s.$$.fragment),Pg=h(),vs=c("p"),Dg=s(`Prepares a PyTorch Scheduler for training in any distributed setup. It is recommended to use
`),mo=c("a"),Tg=s("Accelerator.prepare()"),zg=s(" instead."),Cg=h(),v(Ea.$$.fragment),Og=h(),Le=c("div"),v(bs.$$.fragment),Lg=h(),ws=c("p"),Sg=s("Drop in replacement of "),Cl=c("code"),Ig=s("print()"),qg=s(" to only print once per server."),Ng=h(),v(xa.$$.fragment),Mg=h(),re=c("div"),v(ys.$$.fragment),Ug=h(),ct=c("p"),Rg=s("Reduce the values in "),Ol=c("em"),Gg=s("tensor"),Vg=s(" across all processes based on "),Ll=c("em"),Wg=s("reduction"),Fg=s("."),Hg=h(),Sl=c("p"),Yg=s(`Note:
All processes get the reduced value.`),Bg=h(),v(Pa.$$.fragment),Jg=h(),F=c("div"),v(js.$$.fragment),Kg=h(),de=c("p"),Qg=s("Makes note of "),Il=c("code"),Xg=s("objects"),Zg=s(" and will save or load them in during "),ql=c("code"),e_=s("save_state"),t_=s(" or "),Nl=c("code"),a_=s("load_state"),r_=s("."),s_=h(),Ml=c("p"),o_=s(`These should be utilized when the state is being loaded or saved in the same script. It is not designed to be
used in different scripts.`),c_=h(),v(Da.$$.fragment),l_=h(),v(Ta.$$.fragment),n_=h(),M=c("div"),v(As.$$.fragment),p_=h(),lt=c("p"),i_=s("Registers a pre hook to be run before "),Ul=c("code"),d_=s("load_checkpoint"),m_=s(" is called in "),ho=c("a"),h_=s("Accelerator.load_state()"),f_=s("."),u_=h(),Rl=c("p"),g_=s("The hook should have the following signature:"),__=h(),Gl=c("p"),Vl=c("code"),$_=s("hook(models: List[torch.nn.Module], input_dir: str) -> None"),v_=h(),V=c("p"),b_=s("The "),Wl=c("code"),w_=s("models"),y_=s(" argument are the models as saved in the accelerator state under "),Fl=c("code"),j_=s("accelerator._models"),A_=s(`, and the
`),Hl=c("code"),k_=s("input_dir"),E_=s(" argument is the "),Yl=c("code"),x_=s("input_dir"),P_=s(" argument passed to "),fo=c("a"),D_=s("Accelerator.load_state()"),T_=s("."),z_=h(),v(za.$$.fragment),C_=h(),U=c("div"),v(ks.$$.fragment),O_=h(),nt=c("p"),L_=s("Registers a pre hook to be run before "),Bl=c("code"),S_=s("save_checkpoint"),I_=s(" is called in "),uo=c("a"),q_=s("Accelerator.save_state()"),N_=s("."),M_=h(),Jl=c("p"),U_=s("The hook should have the following signature:"),R_=h(),Kl=c("p"),Ql=c("code"),G_=s("hook(models: List[torch.nn.Module], weights: List[Dict[str, torch.Tensor]], input_dir: str) -> None"),V_=h(),I=c("p"),W_=s("The "),Xl=c("code"),F_=s("models"),H_=s(" argument are the models as saved in the accelerator state under "),Zl=c("code"),Y_=s("accelerator._models"),B_=s(", "),en=c("code"),J_=s("weigths"),K_=s(`
argument are the state dicts of the `),tn=c("code"),Q_=s("models"),X_=s(", and the "),an=c("code"),Z_=s("input_dir"),e$=s(" argument is the "),rn=c("code"),t$=s("input_dir"),a$=s(` argument passed
to `),go=c("a"),r$=s("Accelerator.load_state()"),s$=s("."),o$=h(),v(Ca.$$.fragment),c$=h(),Se=c("div"),v(Es.$$.fragment),l$=h(),xs=c("p"),n$=s("Save the object passed to disk once per machine. Use in place of "),sn=c("code"),p$=s("torch.save"),i$=s("."),d$=h(),v(Oa.$$.fragment),m$=h(),R=c("div"),v(Ps.$$.fragment),h$=h(),on=c("p"),f$=s("Saves the current states of the model, optimizer, scaler, RNG generators, and registered objects to a folder."),u$=h(),N=c("p"),g$=s("If a "),cn=c("code"),_$=s("ProjectConfiguration"),$$=s(" was passed to the "),ln=c("code"),v$=s("Accelerator"),b$=s(" object with "),nn=c("code"),w$=s("automatic_checkpoint_naming"),y$=s(` enabled
then checkpoints will be saved to `),pn=c("code"),j$=s("self.project_dir/checkpoints"),A$=s(`. If the number of current saves is greater
than `),dn=c("code"),k$=s("total_limit"),E$=s(` then the oldest save is deleted. Each checkpoint is saved in seperate folders named
`),mn=c("code"),x$=s("checkpoint_<iteration>"),P$=s("."),D$=h(),Ds=c("p"),T$=s("Otherwise they are just saved to "),hn=c("code"),z$=s("output_dir"),C$=s("."),O$=h(),v(La.$$.fragment),L$=h(),v(Sa.$$.fragment),S$=h(),Ie=c("div"),v(Ts.$$.fragment),I$=h(),pt=c("p"),q$=s("Creates a new "),fn=c("code"),N$=s("torch.utils.data.DataLoader"),M$=s(" that will efficiently skip the first "),un=c("code"),U$=s("num_batches"),R$=s("."),G$=h(),v(Ia.$$.fragment),V$=h(),se=c("div"),v(zs.$$.fragment),W$=h(),gn=c("p"),F$=s("Unscale the gradients in mixed precision training with AMP. This is a noop in all other settings."),H$=h(),qa=c("p"),Y$=s("Likely should be called through "),Na=c("a"),B$=s("Accelerator.clip"),_n=c("em"),J$=s("grad_norm"),K$=s("()"),Q$=s(" or "),Ma=c("a"),X$=s("Accelerator.clip"),$n=c("em"),Z$=s("grad_value"),ev=s("()"),tv=h(),v(Ua.$$.fragment),av=h(),qe=c("div"),v(Cs.$$.fragment),rv=h(),it=c("p"),sv=s("Unwraps the "),vn=c("code"),ov=s("model"),cv=s(" from the additional layer possible added by "),_o=c("a"),lv=s("prepare()"),nv=s(`. Useful before saving
the model.`),pv=h(),v(Ra.$$.fragment),iv=h(),Ne=c("div"),v(Os.$$.fragment),dv=h(),bn=c("p"),mv=s(`Will stop the execution of the current process until every other process has reached that point (so this does
nothing when the script is only run in one process). Useful to do before saving a model.`),hv=h(),v(Ga.$$.fragment),this.h()},l(a){const _=Q1('[data-svelte="svelte-1phssyn"]',document.head);p=l(_,"META",{name:!0,content:!0}),_.forEach(r),g=f(a),m=l(a,"H1",{class:!0});var Ls=n(m);i=l(Ls,"A",{id:!0,class:!0,href:!0});var wn=n(i);u=l(wn,"SPAN",{});var yn=n(u);b(t.$$.fragment,yn),yn.forEach(r),wn.forEach(r),d=f(Ls),L=l(Ls,"SPAN",{});var jn=n(L);Ge=o(jn,"Accelerator"),jn.forEach(r),Ls.forEach(r),ft=f(a),J=l(a,"P",{});var Ss=n(J);Ve=o(Ss,"The "),q=l(Ss,"A",{href:!0});var An=n(q);Ws=o(An,"Accelerator"),An.forEach(r),Fs=o(Ss,` is the main class provided by \u{1F917} Accelerate.
It serves at the main entrypoint for the API.`),Ss.forEach(r),ar=f(a),We=l(a,"H2",{class:!0});var Is=n(We);ut=l(Is,"A",{id:!0,class:!0,href:!0});var kn=n(ut);Ko=l(kn,"SPAN",{});var En=n(Ko);b(rr.$$.fragment,En),En.forEach(r),kn.forEach(r),Si=f(Is),Qo=l(Is,"SPAN",{});var xn=n(Qo);Ii=o(xn,"Quick adaptation of your code"),xn.forEach(r),Is.forEach(r),np=f(a),Hs=l(a,"P",{});var Pn=n(Hs);qi=o(Pn,"To quickly adapt your script to work on any kind of setup with \u{1F917} Accelerate just:"),Pn.forEach(r),pp=f(a),he=l(a,"OL",{});var dt=n(he);Fe=l(dt,"LI",{});var mt=n(Fe);Ni=o(mt,"Initialize an "),Ys=l(mt,"A",{href:!0});var Dn=n(Ys);Mi=o(Dn,"Accelerator"),Dn.forEach(r),Ui=o(mt," object (that we will call "),Xo=l(mt,"CODE",{});var Tn=n(Xo);Ri=o(Tn,"accelerator"),Tn.forEach(r),Gi=o(mt," throughout this page) as early as possible in your script."),mt.forEach(r),Vi=f(dt),sr=l(dt,"LI",{});var qs=n(sr);Wi=o(qs,"Pass your dataloader(s), model(s), optimizer(s), and scheduler(s) to the "),Bs=l(qs,"A",{href:!0});var zn=n(Bs);Fi=o(zn,"prepare()"),zn.forEach(r),Hi=o(qs," method."),qs.forEach(r),Yi=f(dt),pe=l(dt,"LI",{});var me=n(pe);Bi=o(me,"Remove all the "),Zo=l(me,"CODE",{});var Cn=n(Zo);Ji=o(Cn,".cuda()"),Cn.forEach(r),Ki=o(me," or "),ec=l(me,"CODE",{});var On=n(ec);Qi=o(On,".to(device)"),On.forEach(r),Xi=o(me," from your code and let the "),tc=l(me,"CODE",{});var Ln=n(tc);Zi=o(Ln,"accelerator"),Ln.forEach(r),ed=o(me," handle the device placement for you."),me.forEach(r),dt.forEach(r),ip=f(a),b(gt.$$.fragment,a),dp=f(a),He=l(a,"OL",{start:!0});var Ns=n(He);_t=l(Ns,"LI",{});var Va=n(_t);td=o(Va,"Replace "),ac=l(Va,"CODE",{});var Sn=n(ac);ad=o(Sn,"loss.backward()"),Sn.forEach(r),rd=o(Va," in your code with "),rc=l(Va,"CODE",{});var In=n(rc);sd=o(In,"accelerator.backward(loss)"),In.forEach(r),Va.forEach(r),od=f(Ns),Js=l(Ns,"LI",{});var $o=n(Js);cd=o($o,"Gather your predictions and labels before storing them or using them for metric computation using "),Ks=l($o,"A",{href:!0});var qn=n(Ks);ld=o(qn,"gather()"),qn.forEach(r),$o.forEach(r),Ns.forEach(r),mp=f(a),b($t.$$.fragment,a),hp=f(a),vt=l(a,"P",{});var Ms=n(vt);nd=o(Ms,`In most cases this is all that is needed. The next section lists a few more advanced use cases and nice features
you should search for and replace by the corresponding methods of your `),sc=l(Ms,"CODE",{});var Nn=n(sc);pd=o(Nn,"accelerator"),Nn.forEach(r),id=o(Ms,":"),Ms.forEach(r),fp=f(a),Ye=l(a,"H2",{class:!0});var Us=n(Ye);bt=l(Us,"A",{id:!0,class:!0,href:!0});var Mn=n(bt);oc=l(Mn,"SPAN",{});var Un=n(oc);b(or.$$.fragment,Un),Un.forEach(r),Mn.forEach(r),dd=f(Us),cc=l(Us,"SPAN",{});var Rn=n(cc);md=o(Rn,"Advanced recommendations"),Rn.forEach(r),Us.forEach(r),up=f(a),Be=l(a,"H3",{class:!0});var Rs=n(Be);wt=l(Rs,"A",{id:!0,class:!0,href:!0});var Gn=n(wt);lc=l(Gn,"SPAN",{});var Vn=n(lc);b(cr.$$.fragment,Vn),Vn.forEach(r),Gn.forEach(r),hd=f(Rs),nc=l(Rs,"SPAN",{});var Wn=n(nc);fd=o(Wn,"Printing"),Wn.forEach(r),Rs.forEach(r),gp=f(a),Je=l(a,"P",{});var Wa=n(Je);pc=l(Wa,"CODE",{});var Fn=n(pc);ud=o(Fn,"print"),Fn.forEach(r),gd=o(Wa," statements should be replaced by "),Qs=l(Wa,"A",{href:!0});var Hn=n(Qs);_d=o(Hn,"print()"),Hn.forEach(r),$d=o(Wa," to be printed once per process"),Wa.forEach(r),_p=f(a),b(lr.$$.fragment,a),$p=f(a),Ke=l(a,"H3",{class:!0});var Gs=n(Ke);yt=l(Gs,"A",{id:!0,class:!0,href:!0});var Yn=n(yt);ic=l(Yn,"SPAN",{});var Bn=n(ic);b(nr.$$.fragment,Bn),Bn.forEach(r),Yn.forEach(r),vd=f(Gs),dc=l(Gs,"SPAN",{});var Jn=n(dc);bd=o(Jn,"Executing processes"),Jn.forEach(r),Gs.forEach(r),vp=f(a),Qe=l(a,"H4",{class:!0});var Vs=n(Qe);jt=l(Vs,"A",{id:!0,class:!0,href:!0});var Kn=n(jt);mc=l(Kn,"SPAN",{});var fv=n(mc);b(pr.$$.fragment,fv),fv.forEach(r),Kn.forEach(r),wd=f(Vs),hc=l(Vs,"SPAN",{});var uv=n(hc);yd=o(uv,"Once on a single server"),uv.forEach(r),Vs.forEach(r),bp=f(a),At=l(a,"P",{});var Bp=n(At);jd=o(Bp,"For statements that should be executed once per server, use "),fc=l(Bp,"CODE",{});var gv=n(fc);Ad=o(gv,"is_local_main_process"),gv.forEach(r),kd=o(Bp,":"),Bp.forEach(r),wp=f(a),b(ir.$$.fragment,a),yp=f(a),kt=l(a,"P",{});var Jp=n(kt);Ed=o(Jp,"A function can be wrapped using the "),Xs=l(Jp,"A",{href:!0});var _v=n(Xs);xd=o(_v,"on_local_main_process()"),_v.forEach(r),Pd=o(Jp,` function to achieve the same
behavior on a function\u2019s execution:`),Jp.forEach(r),jp=f(a),b(dr.$$.fragment,a),Ap=f(a),Xe=l(a,"H4",{class:!0});var Kp=n(Xe);Et=l(Kp,"A",{id:!0,class:!0,href:!0});var $v=n(Et);uc=l($v,"SPAN",{});var vv=n(uc);b(mr.$$.fragment,vv),vv.forEach(r),$v.forEach(r),Dd=f(Kp),gc=l(Kp,"SPAN",{});var bv=n(gc);Td=o(bv,"Only ever once across all servers"),bv.forEach(r),Kp.forEach(r),kp=f(a),xt=l(a,"P",{});var Qp=n(xt);zd=o(Qp,"For statements that should only ever be executed once, use "),_c=l(Qp,"CODE",{});var wv=n(_c);Cd=o(wv,"is_main_process"),wv.forEach(r),Od=o(Qp,":"),Qp.forEach(r),Ep=f(a),b(hr.$$.fragment,a),xp=f(a),Pt=l(a,"P",{});var Xp=n(Pt);Ld=o(Xp,"A function can be wrapped using the "),Zs=l(Xp,"A",{href:!0});var yv=n(Zs);Sd=o(yv,"on_main_process()"),yv.forEach(r),Id=o(Xp,` function to achieve the same
behavior on a function\u2019s execution:`),Xp.forEach(r),Pp=f(a),b(fr.$$.fragment,a),Dp=f(a),Ze=l(a,"H4",{class:!0});var Zp=n(Ze);Dt=l(Zp,"A",{id:!0,class:!0,href:!0});var jv=n(Dt);$c=l(jv,"SPAN",{});var Av=n($c);b(ur.$$.fragment,Av),Av.forEach(r),jv.forEach(r),qd=f(Zp),vc=l(Zp,"SPAN",{});var kv=n(vc);Nd=o(kv,"On specific processes"),kv.forEach(r),Zp.forEach(r),Tp=f(a),eo=l(a,"P",{});var Ev=n(eo);Md=o(Ev,`If a function should be ran on a specific overall or local process index, there are similar decorators
to achieve this:`),Ev.forEach(r),zp=f(a),b(gr.$$.fragment,a),Cp=f(a),b(_r.$$.fragment,a),Op=f(a),et=l(a,"H3",{class:!0});var ei=n(et);Tt=l(ei,"A",{id:!0,class:!0,href:!0});var xv=n(Tt);bc=l(xv,"SPAN",{});var Pv=n(bc);b($r.$$.fragment,Pv),Pv.forEach(r),xv.forEach(r),Ud=f(ei),wc=l(ei,"SPAN",{});var Dv=n(wc);Rd=o(Dv,"Synchronicity control"),Dv.forEach(r),ei.forEach(r),Lp=f(a),zt=l(a,"P",{});var ti=n(zt);Gd=o(ti,"Use "),to=l(ti,"A",{href:!0});var Tv=n(to);Vd=o(Tv,"wait_for_everyone()"),Tv.forEach(r),Wd=o(ti," to make sure all processes join that point before continuing. (Useful before a model save for instance)"),ti.forEach(r),Sp=f(a),tt=l(a,"H3",{class:!0});var ai=n(tt);Ct=l(ai,"A",{id:!0,class:!0,href:!0});var zv=n(Ct);yc=l(zv,"SPAN",{});var Cv=n(yc);b(vr.$$.fragment,Cv),Cv.forEach(r),zv.forEach(r),Fd=f(ai),jc=l(ai,"SPAN",{});var Ov=n(jc);Hd=o(Ov,"Saving and loading"),Ov.forEach(r),ai.forEach(r),Ip=f(a),Ot=l(a,"P",{});var ri=n(Ot);Yd=o(ri,"Use "),ao=l(ri,"A",{href:!0});var Lv=n(ao);Bd=o(Lv,"unwrap_model()"),Lv.forEach(r),Jd=o(ri," before saving to remove all special model wrappers added during the distributed process."),ri.forEach(r),qp=f(a),b(br.$$.fragment,a),Np=f(a),fe=l(a,"P",{});var vo=n(fe);Kd=o(vo,"Use "),ro=l(vo,"A",{href:!0});var Sv=n(ro);Qd=o(Sv,"save()"),Sv.forEach(r),Xd=o(vo," instead of "),Ac=l(vo,"CODE",{});var Iv=n(Ac);Zd=o(Iv,"torch.save"),Iv.forEach(r),em=o(vo,":"),vo.forEach(r),Mp=f(a),b(wr.$$.fragment,a),Up=f(a),at=l(a,"H3",{class:!0});var si=n(at);Lt=l(si,"A",{id:!0,class:!0,href:!0});var qv=n(Lt);kc=l(qv,"SPAN",{});var Nv=n(kc);b(yr.$$.fragment,Nv),Nv.forEach(r),qv.forEach(r),tm=f(si),Ec=l(si,"SPAN",{});var Mv=n(Ec);am=o(Mv,"Operations"),Mv.forEach(r),si.forEach(r),Rp=f(a),Y=l(a,"P",{});var ht=n(Y);rm=o(ht,"Use "),St=l(ht,"A",{href:!0});var oi=n(St);sm=o(oi,"clip"),xc=l(oi,"EM",{});var Uv=n(xc);om=o(Uv,"grad_norm"),Uv.forEach(r),cm=o(oi,"()"),oi.forEach(r),lm=o(ht," instead of "),Pc=l(ht,"CODE",{});var Rv=n(Pc);nm=o(Rv,"torch.nn.utils.clip_grad_norm_"),Rv.forEach(r),pm=o(ht," and "),It=l(ht,"A",{href:!0});var ci=n(It);im=o(ci,"clip"),Dc=l(ci,"EM",{});var Gv=n(Dc);dm=o(Gv,"grad_value"),Gv.forEach(r),mm=o(ci,"()"),ci.forEach(r),hm=o(ht," instead of "),Tc=l(ht,"CODE",{});var Vv=n(Tc);fm=o(Vv,"torch.nn.utils.clip_grad_value"),Vv.forEach(r),ht.forEach(r),Gp=f(a),rt=l(a,"H3",{class:!0});var li=n(rt);qt=l(li,"A",{id:!0,class:!0,href:!0});var Wv=n(qt);zc=l(Wv,"SPAN",{});var Fv=n(zc);b(jr.$$.fragment,Fv),Fv.forEach(r),Wv.forEach(r),um=f(li),Cc=l(li,"SPAN",{});var Hv=n(Cc);gm=o(Hv,"Gradient Accumulation"),Hv.forEach(r),li.forEach(r),Vp=f(a),Nt=l(a,"P",{});var ni=n(Nt);_m=o(ni,"To perform gradient accumulation use "),so=l(ni,"A",{href:!0});var Yv=n(so);$m=o(Yv,"accumulate()"),Yv.forEach(r),vm=o(ni,` and specify a gradient_accumulation_steps.
This will also automatically ensure the gradients are synced or unsynced when on
multi-device training, check if the step should actually be performed, and auto-scale the loss:`),ni.forEach(r),Wp=f(a),b(Ar.$$.fragment,a),Fp=f(a),st=l(a,"H2",{class:!0});var pi=n(st);Mt=l(pi,"A",{id:!0,class:!0,href:!0});var Bv=n(Mt);Oc=l(Bv,"SPAN",{});var Jv=n(Oc);b(kr.$$.fragment,Jv),Jv.forEach(r),Bv.forEach(r),bm=f(pi),Lc=l(pi,"SPAN",{});var Kv=n(Lc);wm=o(Kv,"Overall API documentation:"),Kv.forEach(r),pi.forEach(r),Hp=f(a),x=l(a,"DIV",{class:!0});var P=n(x);b(Er.$$.fragment,P),ym=f(P),Sc=l(P,"P",{});var Qv=n(Sc);jm=o(Qv,"Creates an instance of an accelerator for distributed training (on multi-GPU, TPU) or mixed precision training."),Qv.forEach(r),Am=f(P),Ic=l(P,"P",{});var Xv=n(Ic);qc=l(Xv,"STRONG",{});var Zv=n(qc);km=o(Zv,"Available attributes:"),Zv.forEach(r),Xv.forEach(r),Em=f(P),O=l(P,"UL",{});var S=n(O);Ut=l(S,"LI",{});var Qn=n(Ut);Nc=l(Qn,"STRONG",{});var eb=n(Nc);xm=o(eb,"device"),eb.forEach(r),Pm=o(Qn," ("),Mc=l(Qn,"CODE",{});var tb=n(Mc);Dm=o(tb,"torch.device"),tb.forEach(r),Tm=o(Qn,") \u2014 The device to use."),Qn.forEach(r),zm=f(S),Rt=l(S,"LI",{});var Xn=n(Rt);Uc=l(Xn,"STRONG",{});var ab=n(Uc);Cm=o(ab,"distributed_type"),ab.forEach(r),Om=o(Xn," ("),oo=l(Xn,"A",{href:!0});var rb=n(oo);Lm=o(rb,"DistributedType"),rb.forEach(r),Sm=o(Xn,") \u2014 The distributed training configuration."),Xn.forEach(r),Im=f(S),Gt=l(S,"LI",{});var Zn=n(Gt);Rc=l(Zn,"STRONG",{});var sb=n(Rc);qm=o(sb,"local_process_index"),sb.forEach(r),Nm=o(Zn," ("),Gc=l(Zn,"CODE",{});var ob=n(Gc);Mm=o(ob,"int"),ob.forEach(r),Um=o(Zn,") \u2014 The process index on the current machine."),Zn.forEach(r),Rm=f(S),Vt=l(S,"LI",{});var ep=n(Vt);Vc=l(ep,"STRONG",{});var cb=n(Vc);Gm=o(cb,"mixed_precision"),cb.forEach(r),Vm=o(ep," ("),Wc=l(ep,"CODE",{});var lb=n(Wc);Wm=o(lb,"str"),lb.forEach(r),Fm=o(ep,") \u2014 The configured mixed precision mode."),ep.forEach(r),Hm=f(S),Wt=l(S,"LI",{});var tp=n(Wt);Fc=l(tp,"STRONG",{});var nb=n(Fc);Ym=o(nb,"num_processes"),nb.forEach(r),Bm=o(tp," ("),Hc=l(tp,"CODE",{});var pb=n(Hc);Jm=o(pb,"int"),pb.forEach(r),Km=o(tp,") \u2014 The total number of processes used for training."),tp.forEach(r),Qm=f(S),Ft=l(S,"LI",{});var ap=n(Ft);Yc=l(ap,"STRONG",{});var ib=n(Yc);Xm=o(ib,"optimizer_step_was_skipped"),ib.forEach(r),Zm=o(ap," ("),Bc=l(ap,"CODE",{});var db=n(Bc);eh=o(db,"bool"),db.forEach(r),th=o(ap,`) \u2014 Whether or not the optimizer update was skipped (because of
gradient overflow in mixed precision), in which
case the learning rate should not be changed.`),ap.forEach(r),ah=f(S),Ht=l(S,"LI",{});var rp=n(Ht);Jc=l(rp,"STRONG",{});var mb=n(Jc);rh=o(mb,"process_index"),mb.forEach(r),sh=o(rp," ("),Kc=l(rp,"CODE",{});var hb=n(Kc);oh=o(hb,"int"),hb.forEach(r),ch=o(rp,") \u2014 The overall index of the current process among all processes."),rp.forEach(r),lh=f(S),Yt=l(S,"LI",{});var sp=n(Yt);Qc=l(sp,"STRONG",{});var fb=n(Qc);nh=o(fb,"state"),fb.forEach(r),ph=o(sp," ("),co=l(sp,"A",{href:!0});var ub=n(co);ih=o(ub,"AcceleratorState"),ub.forEach(r),dh=o(sp,") \u2014 The distributed setup state."),sp.forEach(r),mh=f(S),Bt=l(S,"LI",{});var op=n(Bt);Xc=l(op,"STRONG",{});var gb=n(Xc);hh=o(gb,"sync_gradients"),gb.forEach(r),fh=o(op," ("),Zc=l(op,"CODE",{});var _b=n(Zc);uh=o(_b,"bool"),_b.forEach(r),gh=o(op,") \u2014 Whether the gradients are currently being synced across all processes."),op.forEach(r),_h=f(S),Jt=l(S,"LI",{});var cp=n(Jt);el=l(cp,"STRONG",{});var $b=n(el);$h=o($b,"use_distributed"),$b.forEach(r),vh=o(cp," ("),tl=l(cp,"CODE",{});var vb=n(tl);bh=o(vb,"bool"),vb.forEach(r),wh=o(cp,") \u2014 Whether the current configuration is for distributed training."),cp.forEach(r),S.forEach(r),yh=f(P),ue=l(P,"DIV",{class:!0});var bo=n(ue);b(xr.$$.fragment,bo),jh=f(bo),al=l(bo,"P",{});var bb=n(al);Ah=o(bb,"A context manager that will lightly wrap around and perform gradient accumulation automatically"),bb.forEach(r),kh=f(bo),b(Kt.$$.fragment,bo),bo.forEach(r),Eh=f(P),ge=l(P,"DIV",{class:!0});var wo=n(ge);b(Pr.$$.fragment,wo),xh=f(wo),rl=l(wo,"P",{});var wb=n(rl);Ph=o(wb,`Will apply automatic mixed-precision inside the block inside this context manager, if it is enabled. Nothing
different will happen otherwise.`),wb.forEach(r),Dh=f(wo),b(Qt.$$.fragment,wo),wo.forEach(r),Th=f(P),K=l(P,"DIV",{class:!0});var Fa=n(K);b(Dr.$$.fragment,Fa),zh=f(Fa),ot=l(Fa,"P",{});var yo=n(ot);Ch=o(yo,"Scales the gradients in accordance to "),sl=l(yo,"CODE",{});var yb=n(sl);Oh=o(yb,"Accelerator.gradient_accumulation_steps"),yb.forEach(r),Lh=o(yo,` and calls the correct
`),ol=l(yo,"CODE",{});var jb=n(ol);Sh=o(jb,"backward()"),jb.forEach(r),Ih=o(yo," based on the configuration."),yo.forEach(r),qh=f(Fa),Tr=l(Fa,"P",{});var ii=n(Tr);Nh=o(ii,"Should be used in lieu of "),cl=l(ii,"CODE",{});var Ab=n(cl);Mh=o(Ab,"loss.backward()"),Ab.forEach(r),Uh=o(ii,"."),ii.forEach(r),Rh=f(Fa),b(Xt.$$.fragment,Fa),Fa.forEach(r),Gh=f(P),_e=l(P,"DIV",{class:!0});var jo=n(_e);b(zr.$$.fragment,jo),Vh=f(jo),Cr=l(jo,"P",{});var di=n(Cr);Wh=o(di,"Alias for "),ll=l(di,"CODE",{});var kb=n(ll);Fh=o(kb,"Accelerate.free_memory"),kb.forEach(r),Hh=o(di,`, releases all references to the internal objects stored and call the
garbage collector. You should call this method between two trainings with different models/optimizers.`),di.forEach(r),Yh=f(jo),b(Zt.$$.fragment,jo),jo.forEach(r),Bh=f(P),$e=l(P,"DIV",{class:!0});var Ao=n($e);b(Or.$$.fragment,Ao),Jh=f(Ao),Lr=l(Ao,"P",{});var mi=n(Lr);Kh=o(mi,"Should be used in place of "),nl=l(mi,"CODE",{});var Eb=n(nl);Qh=o(Eb,"torch.nn.utils.clip_grad_norm_"),Eb.forEach(r),Xh=o(mi,"."),mi.forEach(r),Zh=f(Ao),b(ea.$$.fragment,Ao),Ao.forEach(r),ef=f(P),ve=l(P,"DIV",{class:!0});var ko=n(ve);b(Sr.$$.fragment,ko),tf=f(ko),Ir=l(ko,"P",{});var hi=n(Ir);af=o(hi,"Should be used in place of "),pl=l(hi,"CODE",{});var xb=n(pl);rf=o(xb,"torch.nn.utils.clip_grad_value_"),xb.forEach(r),sf=o(hi,"."),hi.forEach(r),of=f(ko),b(ta.$$.fragment,ko),ko.forEach(r),cf=f(P),be=l(P,"DIV",{class:!0});var Eo=n(be);b(qr.$$.fragment,Eo),lf=f(Eo),il=l(Eo,"P",{});var Pb=n(il);nf=o(Pb,`Will release all references to the internal objects stored and call the garbage collector. You should call this
method between two trainings with different models/optimizers.`),Pb.forEach(r),pf=f(Eo),b(aa.$$.fragment,Eo),Eo.forEach(r),df=f(P),Q=l(P,"DIV",{class:!0});var Ha=n(Q);b(Nr.$$.fragment,Ha),mf=f(Ha),Mr=l(Ha,"P",{});var fi=n(Mr);hf=o(fi,"Gather the values in "),dl=l(fi,"EM",{});var Db=n(dl);ff=o(Db,"tensor"),Db.forEach(r),uf=o(fi,` across all processes and concatenate them on the first dimension. Useful to
regroup the predictions from all processes when doing evaluation.`),fi.forEach(r),gf=f(Ha),ml=l(Ha,"P",{});var Tb=n(ml);_f=o(Tb,`Note:
This gather happens in all processes.`),Tb.forEach(r),$f=f(Ha),b(ra.$$.fragment,Ha),Ha.forEach(r),vf=f(P),we=l(P,"DIV",{class:!0});var xo=n(we);b(Ur.$$.fragment,xo),bf=f(xo),Rr=l(xo,"P",{});var ui=n(Rr);wf=o(ui,"Gathers "),hl=l(ui,"CODE",{});var zb=n(hl);yf=o(zb,"tensor"),zb.forEach(r),jf=o(ui,` and potentially drops duplicates in the last batch if on a distributed system. Should be used
for gathering the inputs and targets for metric calculation.`),ui.forEach(r),Af=f(xo),b(sa.$$.fragment,xo),xo.forEach(r),kf=f(P),ye=l(P,"DIV",{class:!0});var Po=n(ye);b(Gr.$$.fragment,Po),Ef=f(Po),Vr=l(Po,"P",{});var gi=n(Vr);xf=o(gi,"Returns the state dictionary of a model sent through "),lo=l(gi,"A",{href:!0});var Cb=n(lo);Pf=o(Cb,"Accelerator.prepare()"),Cb.forEach(r),Df=o(gi,` potentially without full
precision.`),gi.forEach(r),Tf=f(Po),b(oa.$$.fragment,Po),Po.forEach(r),zf=f(P),je=l(P,"DIV",{class:!0});var Do=n(je);b(Wr.$$.fragment,Do),Cf=f(Do),ie=l(Do,"P",{});var Ya=n(ie);Of=o(Ya,"Returns a "),fl=l(Ya,"CODE",{});var Ob=n(fl);Lf=o(Ob,"tracker"),Ob.forEach(r),Sf=o(Ya," from "),ul=l(Ya,"CODE",{});var Lb=n(ul);If=o(Lb,"self.trackers"),Lb.forEach(r),qf=o(Ya," based on "),gl=l(Ya,"CODE",{});var Sb=n(gl);Nf=o(Sb,"name"),Sb.forEach(r),Mf=o(Ya," on the main process only."),Ya.forEach(r),Uf=f(Do),b(ca.$$.fragment,Do),Do.forEach(r),Rf=f(P),W=l(P,"DIV",{class:!0});var Me=n(W);b(Fr.$$.fragment,Me),Gf=f(Me),Hr=l(Me,"P",{});var _i=n(Hr);Vf=o(_i,`A context manager that facilitates distributed training or evaluation on uneven inputs, which acts as a wrapper
around `),_l=l(_i,"CODE",{});var Ib=n(_l);Wf=o(Ib,"torch.distributed.algorithms.join"),Ib.forEach(r),Ff=o(_i,`. This is useful when the total batch size does not evenly divide the
length of the dataset.`),_i.forEach(r),Hf=f(Me),b(la.$$.fragment,Me),Yf=f(Me),b(na.$$.fragment,Me),Bf=f(Me),b(pa.$$.fragment,Me),Me.forEach(r),Jf=f(P),X=l(P,"DIV",{class:!0});var Ba=n(X);b(Yr.$$.fragment,Ba),Kf=f(Ba),$l=l(Ba,"P",{});var qb=n($l);Qf=o(qb,"Loads the current states of the model, optimizer, scaler, RNG generators, and registered objects."),qb.forEach(r),Xf=f(Ba),b(ia.$$.fragment,Ba),Zf=f(Ba),b(da.$$.fragment,Ba),Ba.forEach(r),eu=f(P),Z=l(P,"DIV",{class:!0});var Ja=n(Z);b(Br.$$.fragment,Ja),tu=f(Ja),vl=l(Ja,"P",{});var Nb=n(vl);au=o(Nb,"Lets the local main process go inside a with block."),Nb.forEach(r),ru=f(Ja),bl=l(Ja,"P",{});var Mb=n(bl);su=o(Mb,"The other processes will enter the with block after the main process exits."),Mb.forEach(r),ou=f(Ja),b(ma.$$.fragment,Ja),Ja.forEach(r),cu=f(P),ee=l(P,"DIV",{class:!0});var Ka=n(ee);b(Jr.$$.fragment,Ka),lu=f(Ka),wl=l(Ka,"P",{});var Ub=n(wl);nu=o(Ub,"Lets the main process go first inside a with block."),Ub.forEach(r),pu=f(Ka),yl=l(Ka,"P",{});var Rb=n(yl);iu=o(Rb,"The other processes will enter the with block after the main process exits."),Rb.forEach(r),du=f(Ka),b(ha.$$.fragment,Ka),Ka.forEach(r),mu=f(P),te=l(P,"DIV",{class:!0});var Qa=n(te);b(Kr.$$.fragment,Qa),hu=f(Qa),Qr=l(Qa,"P",{});var $i=n(Qr);fu=o($i,`A context manager to disable gradient synchronizations across DDP processes by calling
`),jl=l($i,"CODE",{});var Gb=n(jl);uu=o(Gb,"torch.nn.parallel.DistributedDataParallel.no_sync"),Gb.forEach(r),gu=o($i,"."),$i.forEach(r),_u=f(Qa),Xr=l(Qa,"P",{});var vi=n(Xr);$u=o(vi,"If "),Al=l(vi,"CODE",{});var Vb=n(Al);vu=o(Vb,"model"),Vb.forEach(r),bu=o(vi," is not in DDP, this context manager does nothing"),vi.forEach(r),wu=f(Qa),b(fa.$$.fragment,Qa),Qa.forEach(r),yu=f(P),Ae=l(P,"DIV",{class:!0});var To=n(Ae);b(Zr.$$.fragment,To),ju=f(To),es=l(To,"P",{});var bi=n(es);Au=o(bi,`A decorator that will run the decorated function on the last process only. Can also be called using the
`),kl=l(bi,"CODE",{});var Wb=n(kl);ku=o(Wb,"PartialState"),Wb.forEach(r),Eu=o(bi," class."),bi.forEach(r),xu=f(To),b(ua.$$.fragment,To),To.forEach(r),Pu=f(P),ke=l(P,"DIV",{class:!0});var zo=n(ke);b(ts.$$.fragment,zo),Du=f(zo),as=l(zo,"P",{});var wi=n(as);Tu=o(wi,`A decorator that will run the decorated function on the local main process only. Can also be called using the
`),El=l(wi,"CODE",{});var Fb=n(El);zu=o(Fb,"PartialState"),Fb.forEach(r),Cu=o(wi," class."),wi.forEach(r),Ou=f(zo),b(ga.$$.fragment,zo),zo.forEach(r),Lu=f(P),Ee=l(P,"DIV",{class:!0});var Co=n(Ee);b(rs.$$.fragment,Co),Su=f(Co),ss=l(Co,"P",{});var yi=n(ss);Iu=o(yi,`A decorator that will run the decorated function on a given local process index only. Can also be called using
the `),xl=l(yi,"CODE",{});var Hb=n(xl);qu=o(Hb,"PartialState"),Hb.forEach(r),Nu=o(yi," class."),yi.forEach(r),Mu=f(Co),b(_a.$$.fragment,Co),Co.forEach(r),Uu=f(P),xe=l(P,"DIV",{class:!0});var Oo=n(xe);b(os.$$.fragment,Oo),Ru=f(Oo),cs=l(Oo,"P",{});var ji=n(cs);Gu=o(ji,`A decorator that will run the decorated function on the main process only. Can also be called using the
`),Pl=l(ji,"CODE",{});var Yb=n(Pl);Vu=o(Yb,"PartialState"),Yb.forEach(r),Wu=o(ji," class."),ji.forEach(r),Fu=f(Oo),b($a.$$.fragment,Oo),Oo.forEach(r),Hu=f(P),Pe=l(P,"DIV",{class:!0});var Lo=n(Pe);b(ls.$$.fragment,Lo),Yu=f(Lo),ns=l(Lo,"P",{});var Ai=n(ns);Bu=o(Ai,`A decorator that will run the decorated function on a given process index only. Can also be called using the
`),Dl=l(Ai,"CODE",{});var Bb=n(Dl);Ju=o(Bb,"PartialState"),Bb.forEach(r),Ku=o(Ai," class."),Ai.forEach(r),Qu=f(Lo),b(va.$$.fragment,Lo),Lo.forEach(r),Xu=f(P),De=l(P,"DIV",{class:!0});var So=n(De);b(ps.$$.fragment,So),Zu=f(So),Tl=l(So,"P",{});var Jb=n(Tl);eg=o(Jb,`Recursively pad the tensors in a nested list/tuple/dictionary of tensors from all devices to the same size so
they can safely be gathered.`),Jb.forEach(r),tg=f(So),b(ba.$$.fragment,So),So.forEach(r),ag=f(P),ae=l(P,"DIV",{class:!0});var Xa=n(ae);b(is.$$.fragment,Xa),rg=f(Xa),ds=l(Xa,"P",{});var ki=n(ds);sg=o(ki,"Prepare all objects passed in "),zl=l(ki,"CODE",{});var Kb=n(zl);og=o(Kb,"args"),Kb.forEach(r),cg=o(ki,` for distributed training and mixed precision, then return them in the same
order.`),ki.forEach(r),lg=f(Xa),b(wa.$$.fragment,Xa),ng=f(Xa),b(ya.$$.fragment,Xa),Xa.forEach(r),pg=f(P),Te=l(P,"DIV",{class:!0});var Io=n(Te);b(ms.$$.fragment,Io),ig=f(Io),hs=l(Io,"P",{});var Ei=n(hs);dg=o(Ei,`Prepares a PyTorch DataLoader for training in any distributed setup. It is recommended to use
`),no=l(Ei,"A",{href:!0});var Qb=n(no);mg=o(Qb,"Accelerator.prepare()"),Qb.forEach(r),hg=o(Ei," instead."),Ei.forEach(r),fg=f(Io),b(ja.$$.fragment,Io),Io.forEach(r),ug=f(P),ze=l(P,"DIV",{class:!0});var qo=n(ze);b(fs.$$.fragment,qo),gg=f(qo),us=l(qo,"P",{});var xi=n(us);_g=o(xi,`Prepares a PyTorch model for training in any distributed setup. It is recommended to use
`),po=l(xi,"A",{href:!0});var Xb=n(po);$g=o(Xb,"Accelerator.prepare()"),Xb.forEach(r),vg=o(xi," instead."),xi.forEach(r),bg=f(qo),b(Aa.$$.fragment,qo),qo.forEach(r),wg=f(P),Ce=l(P,"DIV",{class:!0});var No=n(Ce);b(gs.$$.fragment,No),yg=f(No),_s=l(No,"P",{});var Pi=n(_s);jg=o(Pi,`Prepares a PyTorch Optimizer for training in any distributed setup. It is recommended to use
`),io=l(Pi,"A",{href:!0});var Zb=n(io);Ag=o(Zb,"Accelerator.prepare()"),Zb.forEach(r),kg=o(Pi," instead."),Pi.forEach(r),Eg=f(No),b(ka.$$.fragment,No),No.forEach(r),xg=f(P),Oe=l(P,"DIV",{class:!0});var Mo=n(Oe);b($s.$$.fragment,Mo),Pg=f(Mo),vs=l(Mo,"P",{});var Di=n(vs);Dg=o(Di,`Prepares a PyTorch Scheduler for training in any distributed setup. It is recommended to use
`),mo=l(Di,"A",{href:!0});var e1=n(mo);Tg=o(e1,"Accelerator.prepare()"),e1.forEach(r),zg=o(Di," instead."),Di.forEach(r),Cg=f(Mo),b(Ea.$$.fragment,Mo),Mo.forEach(r),Og=f(P),Le=l(P,"DIV",{class:!0});var Uo=n(Le);b(bs.$$.fragment,Uo),Lg=f(Uo),ws=l(Uo,"P",{});var Ti=n(ws);Sg=o(Ti,"Drop in replacement of "),Cl=l(Ti,"CODE",{});var t1=n(Cl);Ig=o(t1,"print()"),t1.forEach(r),qg=o(Ti," to only print once per server."),Ti.forEach(r),Ng=f(Uo),b(xa.$$.fragment,Uo),Uo.forEach(r),Mg=f(P),re=l(P,"DIV",{class:!0});var Za=n(re);b(ys.$$.fragment,Za),Ug=f(Za),ct=l(Za,"P",{});var Ro=n(ct);Rg=o(Ro,"Reduce the values in "),Ol=l(Ro,"EM",{});var a1=n(Ol);Gg=o(a1,"tensor"),a1.forEach(r),Vg=o(Ro," across all processes based on "),Ll=l(Ro,"EM",{});var r1=n(Ll);Wg=o(r1,"reduction"),r1.forEach(r),Fg=o(Ro,"."),Ro.forEach(r),Hg=f(Za),Sl=l(Za,"P",{});var s1=n(Sl);Yg=o(s1,`Note:
All processes get the reduced value.`),s1.forEach(r),Bg=f(Za),b(Pa.$$.fragment,Za),Za.forEach(r),Jg=f(P),F=l(P,"DIV",{class:!0});var Ue=n(F);b(js.$$.fragment,Ue),Kg=f(Ue),de=l(Ue,"P",{});var er=n(de);Qg=o(er,"Makes note of "),Il=l(er,"CODE",{});var o1=n(Il);Xg=o(o1,"objects"),o1.forEach(r),Zg=o(er," and will save or load them in during "),ql=l(er,"CODE",{});var c1=n(ql);e_=o(c1,"save_state"),c1.forEach(r),t_=o(er," or "),Nl=l(er,"CODE",{});var l1=n(Nl);a_=o(l1,"load_state"),l1.forEach(r),r_=o(er,"."),er.forEach(r),s_=f(Ue),Ml=l(Ue,"P",{});var n1=n(Ml);o_=o(n1,`These should be utilized when the state is being loaded or saved in the same script. It is not designed to be
used in different scripts.`),n1.forEach(r),c_=f(Ue),b(Da.$$.fragment,Ue),l_=f(Ue),b(Ta.$$.fragment,Ue),Ue.forEach(r),n_=f(P),M=l(P,"DIV",{class:!0});var oe=n(M);b(As.$$.fragment,oe),p_=f(oe),lt=l(oe,"P",{});var Go=n(lt);i_=o(Go,"Registers a pre hook to be run before "),Ul=l(Go,"CODE",{});var p1=n(Ul);d_=o(p1,"load_checkpoint"),p1.forEach(r),m_=o(Go," is called in "),ho=l(Go,"A",{href:!0});var i1=n(ho);h_=o(i1,"Accelerator.load_state()"),i1.forEach(r),f_=o(Go,"."),Go.forEach(r),u_=f(oe),Rl=l(oe,"P",{});var d1=n(Rl);g_=o(d1,"The hook should have the following signature:"),d1.forEach(r),__=f(oe),Gl=l(oe,"P",{});var m1=n(Gl);Vl=l(m1,"CODE",{});var h1=n(Vl);$_=o(h1,"hook(models: List[torch.nn.Module], input_dir: str) -> None"),h1.forEach(r),m1.forEach(r),v_=f(oe),V=l(oe,"P",{});var ce=n(V);b_=o(ce,"The "),Wl=l(ce,"CODE",{});var f1=n(Wl);w_=o(f1,"models"),f1.forEach(r),y_=o(ce," argument are the models as saved in the accelerator state under "),Fl=l(ce,"CODE",{});var u1=n(Fl);j_=o(u1,"accelerator._models"),u1.forEach(r),A_=o(ce,`, and the
`),Hl=l(ce,"CODE",{});var g1=n(Hl);k_=o(g1,"input_dir"),g1.forEach(r),E_=o(ce," argument is the "),Yl=l(ce,"CODE",{});var _1=n(Yl);x_=o(_1,"input_dir"),_1.forEach(r),P_=o(ce," argument passed to "),fo=l(ce,"A",{href:!0});var $1=n(fo);D_=o($1,"Accelerator.load_state()"),$1.forEach(r),T_=o(ce,"."),ce.forEach(r),z_=f(oe),b(za.$$.fragment,oe),oe.forEach(r),C_=f(P),U=l(P,"DIV",{class:!0});var le=n(U);b(ks.$$.fragment,le),O_=f(le),nt=l(le,"P",{});var Vo=n(nt);L_=o(Vo,"Registers a pre hook to be run before "),Bl=l(Vo,"CODE",{});var v1=n(Bl);S_=o(v1,"save_checkpoint"),v1.forEach(r),I_=o(Vo," is called in "),uo=l(Vo,"A",{href:!0});var b1=n(uo);q_=o(b1,"Accelerator.save_state()"),b1.forEach(r),N_=o(Vo,"."),Vo.forEach(r),M_=f(le),Jl=l(le,"P",{});var w1=n(Jl);U_=o(w1,"The hook should have the following signature:"),w1.forEach(r),R_=f(le),Kl=l(le,"P",{});var y1=n(Kl);Ql=l(y1,"CODE",{});var j1=n(Ql);G_=o(j1,"hook(models: List[torch.nn.Module], weights: List[Dict[str, torch.Tensor]], input_dir: str) -> None"),j1.forEach(r),y1.forEach(r),V_=f(le),I=l(le,"P",{});var G=n(I);W_=o(G,"The "),Xl=l(G,"CODE",{});var A1=n(Xl);F_=o(A1,"models"),A1.forEach(r),H_=o(G," argument are the models as saved in the accelerator state under "),Zl=l(G,"CODE",{});var k1=n(Zl);Y_=o(k1,"accelerator._models"),k1.forEach(r),B_=o(G,", "),en=l(G,"CODE",{});var E1=n(en);J_=o(E1,"weigths"),E1.forEach(r),K_=o(G,`
argument are the state dicts of the `),tn=l(G,"CODE",{});var x1=n(tn);Q_=o(x1,"models"),x1.forEach(r),X_=o(G,", and the "),an=l(G,"CODE",{});var P1=n(an);Z_=o(P1,"input_dir"),P1.forEach(r),e$=o(G," argument is the "),rn=l(G,"CODE",{});var D1=n(rn);t$=o(D1,"input_dir"),D1.forEach(r),a$=o(G,` argument passed
to `),go=l(G,"A",{href:!0});var T1=n(go);r$=o(T1,"Accelerator.load_state()"),T1.forEach(r),s$=o(G,"."),G.forEach(r),o$=f(le),b(Ca.$$.fragment,le),le.forEach(r),c$=f(P),Se=l(P,"DIV",{class:!0});var Wo=n(Se);b(Es.$$.fragment,Wo),l$=f(Wo),xs=l(Wo,"P",{});var zi=n(xs);n$=o(zi,"Save the object passed to disk once per machine. Use in place of "),sn=l(zi,"CODE",{});var z1=n(sn);p$=o(z1,"torch.save"),z1.forEach(r),i$=o(zi,"."),zi.forEach(r),d$=f(Wo),b(Oa.$$.fragment,Wo),Wo.forEach(r),m$=f(P),R=l(P,"DIV",{class:!0});var ne=n(R);b(Ps.$$.fragment,ne),h$=f(ne),on=l(ne,"P",{});var C1=n(on);f$=o(C1,"Saves the current states of the model, optimizer, scaler, RNG generators, and registered objects to a folder."),C1.forEach(r),u$=f(ne),N=l(ne,"P",{});var H=n(N);g$=o(H,"If a "),cn=l(H,"CODE",{});var O1=n(cn);_$=o(O1,"ProjectConfiguration"),O1.forEach(r),$$=o(H," was passed to the "),ln=l(H,"CODE",{});var L1=n(ln);v$=o(L1,"Accelerator"),L1.forEach(r),b$=o(H," object with "),nn=l(H,"CODE",{});var S1=n(nn);w$=o(S1,"automatic_checkpoint_naming"),S1.forEach(r),y$=o(H,` enabled
then checkpoints will be saved to `),pn=l(H,"CODE",{});var I1=n(pn);j$=o(I1,"self.project_dir/checkpoints"),I1.forEach(r),A$=o(H,`. If the number of current saves is greater
than `),dn=l(H,"CODE",{});var q1=n(dn);k$=o(q1,"total_limit"),q1.forEach(r),E$=o(H,` then the oldest save is deleted. Each checkpoint is saved in seperate folders named
`),mn=l(H,"CODE",{});var N1=n(mn);x$=o(N1,"checkpoint_<iteration>"),N1.forEach(r),P$=o(H,"."),H.forEach(r),D$=f(ne),Ds=l(ne,"P",{});var Ci=n(Ds);T$=o(Ci,"Otherwise they are just saved to "),hn=l(Ci,"CODE",{});var M1=n(hn);z$=o(M1,"output_dir"),M1.forEach(r),C$=o(Ci,"."),Ci.forEach(r),O$=f(ne),b(La.$$.fragment,ne),L$=f(ne),b(Sa.$$.fragment,ne),ne.forEach(r),S$=f(P),Ie=l(P,"DIV",{class:!0});var Fo=n(Ie);b(Ts.$$.fragment,Fo),I$=f(Fo),pt=l(Fo,"P",{});var Ho=n(pt);q$=o(Ho,"Creates a new "),fn=l(Ho,"CODE",{});var U1=n(fn);N$=o(U1,"torch.utils.data.DataLoader"),U1.forEach(r),M$=o(Ho," that will efficiently skip the first "),un=l(Ho,"CODE",{});var R1=n(un);U$=o(R1,"num_batches"),R1.forEach(r),R$=o(Ho,"."),Ho.forEach(r),G$=f(Fo),b(Ia.$$.fragment,Fo),Fo.forEach(r),V$=f(P),se=l(P,"DIV",{class:!0});var tr=n(se);b(zs.$$.fragment,tr),W$=f(tr),gn=l(tr,"P",{});var G1=n(gn);F$=o(G1,"Unscale the gradients in mixed precision training with AMP. This is a noop in all other settings."),G1.forEach(r),H$=f(tr),qa=l(tr,"P",{});var lp=n(qa);Y$=o(lp,"Likely should be called through "),Na=l(lp,"A",{href:!0});var Oi=n(Na);B$=o(Oi,"Accelerator.clip"),_n=l(Oi,"EM",{});var V1=n(_n);J$=o(V1,"grad_norm"),V1.forEach(r),K$=o(Oi,"()"),Oi.forEach(r),Q$=o(lp," or "),Ma=l(lp,"A",{href:!0});var Li=n(Ma);X$=o(Li,"Accelerator.clip"),$n=l(Li,"EM",{});var W1=n($n);Z$=o(W1,"grad_value"),W1.forEach(r),ev=o(Li,"()"),Li.forEach(r),lp.forEach(r),tv=f(tr),b(Ua.$$.fragment,tr),tr.forEach(r),av=f(P),qe=l(P,"DIV",{class:!0});var Yo=n(qe);b(Cs.$$.fragment,Yo),rv=f(Yo),it=l(Yo,"P",{});var Bo=n(it);sv=o(Bo,"Unwraps the "),vn=l(Bo,"CODE",{});var F1=n(vn);ov=o(F1,"model"),F1.forEach(r),cv=o(Bo," from the additional layer possible added by "),_o=l(Bo,"A",{href:!0});var H1=n(_o);lv=o(H1,"prepare()"),H1.forEach(r),nv=o(Bo,`. Useful before saving
the model.`),Bo.forEach(r),pv=f(Yo),b(Ra.$$.fragment,Yo),Yo.forEach(r),iv=f(P),Ne=l(P,"DIV",{class:!0});var Jo=n(Ne);b(Os.$$.fragment,Jo),dv=f(Jo),bn=l(Jo,"P",{});var Y1=n(bn);mv=o(Y1,`Will stop the execution of the current process until every other process has reached that point (so this does
nothing when the script is only run in one process). Useful to do before saving a model.`),Y1.forEach(r),hv=f(Jo),b(Ga.$$.fragment,Jo),Jo.forEach(r),P.forEach(r),this.h()},h(){k(p,"name","hf:doc:metadata"),k(p,"content",JSON.stringify(H2)),k(i,"id","accelerator"),k(i,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),k(i,"href","#accelerator"),k(m,"class","relative group"),k(q,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator"),k(ut,"id","quick-adaptation-of-your-code"),k(ut,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),k(ut,"href","#quick-adaptation-of-your-code"),k(We,"class","relative group"),k(Ys,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator"),k(Bs,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.prepare"),k(Ks,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.gather"),k(He,"start","4"),k(bt,"id","advanced-recommendations"),k(bt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),k(bt,"href","#advanced-recommendations"),k(Ye,"class","relative group"),k(wt,"id","printing"),k(wt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),k(wt,"href","#printing"),k(Be,"class","relative group"),k(Qs,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.print"),k(yt,"id","executing-processes"),k(yt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),k(yt,"href","#executing-processes"),k(Ke,"class","relative group"),k(jt,"id","once-on-a-single-server"),k(jt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),k(jt,"href","#once-on-a-single-server"),k(Qe,"class","relative group"),k(Xs,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.on_local_main_process"),k(Et,"id","only-ever-once-across-all-servers"),k(Et,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),k(Et,"href","#only-ever-once-across-all-servers"),k(Xe,"class","relative group"),k(Zs,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.on_main_process"),k(Dt,"id","on-specific-processes"),k(Dt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),k(Dt,"href","#on-specific-processes"),k(Ze,"class","relative group"),k(Tt,"id","synchronicity-control"),k(Tt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),k(Tt,"href","#synchronicity-control"),k(et,"class","relative group"),k(to,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.wait_for_everyone"),k(Ct,"id","saving-and-loading"),k(Ct,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),k(Ct,"href","#saving-and-loading"),k(tt,"class","relative group"),k(ao,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.unwrap_model"),k(ro,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.save"),k(Lt,"id","operations"),k(Lt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),k(Lt,"href","#operations"),k(at,"class","relative group"),k(St,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_norm_"),k(It,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_value_"),k(qt,"id","gradient-accumulation"),k(qt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),k(qt,"href","#gradient-accumulation"),k(rt,"class","relative group"),k(so,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.accumulate"),k(Mt,"id","accelerate.Accelerator"),k(Mt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),k(Mt,"href","#accelerate.Accelerator"),k(st,"class","relative group"),k(oo,"href","/docs/accelerate/v0.17.1/en/package_reference/utilities#accelerate.DistributedType"),k(co,"href","/docs/accelerate/v0.17.1/en/package_reference/state#accelerate.state.AcceleratorState"),k(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k($e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(we,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(lo,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.prepare"),k(ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(je,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(Ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(Ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(Pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(De,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(no,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.prepare"),k(Te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(po,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.prepare"),k(ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(io,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.prepare"),k(Ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(mo,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.prepare"),k(Oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(Le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(ho,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.load_state"),k(fo,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.load_state"),k(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(uo,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.save_state"),k(go,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.load_state"),k(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(Se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(Ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(Na,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_norm_"),k(Ma,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_value_"),k(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(_o,"href","/docs/accelerate/v0.17.1/en/package_reference/accelerator#accelerate.Accelerator.prepare"),k(qe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(Ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),k(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(a,_){e(document.head,p),$(a,g,_),$(a,m,_),e(m,i),e(i,u),w(t,u,null),e(m,d),e(m,L),e(L,Ge),$(a,ft,_),$(a,J,_),e(J,Ve),e(J,q),e(q,Ws),e(J,Fs),$(a,ar,_),$(a,We,_),e(We,ut),e(ut,Ko),w(rr,Ko,null),e(We,Si),e(We,Qo),e(Qo,Ii),$(a,np,_),$(a,Hs,_),e(Hs,qi),$(a,pp,_),$(a,he,_),e(he,Fe),e(Fe,Ni),e(Fe,Ys),e(Ys,Mi),e(Fe,Ui),e(Fe,Xo),e(Xo,Ri),e(Fe,Gi),e(he,Vi),e(he,sr),e(sr,Wi),e(sr,Bs),e(Bs,Fi),e(sr,Hi),e(he,Yi),e(he,pe),e(pe,Bi),e(pe,Zo),e(Zo,Ji),e(pe,Ki),e(pe,ec),e(ec,Qi),e(pe,Xi),e(pe,tc),e(tc,Zi),e(pe,ed),$(a,ip,_),w(gt,a,_),$(a,dp,_),$(a,He,_),e(He,_t),e(_t,td),e(_t,ac),e(ac,ad),e(_t,rd),e(_t,rc),e(rc,sd),e(He,od),e(He,Js),e(Js,cd),e(Js,Ks),e(Ks,ld),$(a,mp,_),w($t,a,_),$(a,hp,_),$(a,vt,_),e(vt,nd),e(vt,sc),e(sc,pd),e(vt,id),$(a,fp,_),$(a,Ye,_),e(Ye,bt),e(bt,oc),w(or,oc,null),e(Ye,dd),e(Ye,cc),e(cc,md),$(a,up,_),$(a,Be,_),e(Be,wt),e(wt,lc),w(cr,lc,null),e(Be,hd),e(Be,nc),e(nc,fd),$(a,gp,_),$(a,Je,_),e(Je,pc),e(pc,ud),e(Je,gd),e(Je,Qs),e(Qs,_d),e(Je,$d),$(a,_p,_),w(lr,a,_),$(a,$p,_),$(a,Ke,_),e(Ke,yt),e(yt,ic),w(nr,ic,null),e(Ke,vd),e(Ke,dc),e(dc,bd),$(a,vp,_),$(a,Qe,_),e(Qe,jt),e(jt,mc),w(pr,mc,null),e(Qe,wd),e(Qe,hc),e(hc,yd),$(a,bp,_),$(a,At,_),e(At,jd),e(At,fc),e(fc,Ad),e(At,kd),$(a,wp,_),w(ir,a,_),$(a,yp,_),$(a,kt,_),e(kt,Ed),e(kt,Xs),e(Xs,xd),e(kt,Pd),$(a,jp,_),w(dr,a,_),$(a,Ap,_),$(a,Xe,_),e(Xe,Et),e(Et,uc),w(mr,uc,null),e(Xe,Dd),e(Xe,gc),e(gc,Td),$(a,kp,_),$(a,xt,_),e(xt,zd),e(xt,_c),e(_c,Cd),e(xt,Od),$(a,Ep,_),w(hr,a,_),$(a,xp,_),$(a,Pt,_),e(Pt,Ld),e(Pt,Zs),e(Zs,Sd),e(Pt,Id),$(a,Pp,_),w(fr,a,_),$(a,Dp,_),$(a,Ze,_),e(Ze,Dt),e(Dt,$c),w(ur,$c,null),e(Ze,qd),e(Ze,vc),e(vc,Nd),$(a,Tp,_),$(a,eo,_),e(eo,Md),$(a,zp,_),w(gr,a,_),$(a,Cp,_),w(_r,a,_),$(a,Op,_),$(a,et,_),e(et,Tt),e(Tt,bc),w($r,bc,null),e(et,Ud),e(et,wc),e(wc,Rd),$(a,Lp,_),$(a,zt,_),e(zt,Gd),e(zt,to),e(to,Vd),e(zt,Wd),$(a,Sp,_),$(a,tt,_),e(tt,Ct),e(Ct,yc),w(vr,yc,null),e(tt,Fd),e(tt,jc),e(jc,Hd),$(a,Ip,_),$(a,Ot,_),e(Ot,Yd),e(Ot,ao),e(ao,Bd),e(Ot,Jd),$(a,qp,_),w(br,a,_),$(a,Np,_),$(a,fe,_),e(fe,Kd),e(fe,ro),e(ro,Qd),e(fe,Xd),e(fe,Ac),e(Ac,Zd),e(fe,em),$(a,Mp,_),w(wr,a,_),$(a,Up,_),$(a,at,_),e(at,Lt),e(Lt,kc),w(yr,kc,null),e(at,tm),e(at,Ec),e(Ec,am),$(a,Rp,_),$(a,Y,_),e(Y,rm),e(Y,St),e(St,sm),e(St,xc),e(xc,om),e(St,cm),e(Y,lm),e(Y,Pc),e(Pc,nm),e(Y,pm),e(Y,It),e(It,im),e(It,Dc),e(Dc,dm),e(It,mm),e(Y,hm),e(Y,Tc),e(Tc,fm),$(a,Gp,_),$(a,rt,_),e(rt,qt),e(qt,zc),w(jr,zc,null),e(rt,um),e(rt,Cc),e(Cc,gm),$(a,Vp,_),$(a,Nt,_),e(Nt,_m),e(Nt,so),e(so,$m),e(Nt,vm),$(a,Wp,_),w(Ar,a,_),$(a,Fp,_),$(a,st,_),e(st,Mt),e(Mt,Oc),w(kr,Oc,null),e(st,bm),e(st,Lc),e(Lc,wm),$(a,Hp,_),$(a,x,_),w(Er,x,null),e(x,ym),e(x,Sc),e(Sc,jm),e(x,Am),e(x,Ic),e(Ic,qc),e(qc,km),e(x,Em),e(x,O),e(O,Ut),e(Ut,Nc),e(Nc,xm),e(Ut,Pm),e(Ut,Mc),e(Mc,Dm),e(Ut,Tm),e(O,zm),e(O,Rt),e(Rt,Uc),e(Uc,Cm),e(Rt,Om),e(Rt,oo),e(oo,Lm),e(Rt,Sm),e(O,Im),e(O,Gt),e(Gt,Rc),e(Rc,qm),e(Gt,Nm),e(Gt,Gc),e(Gc,Mm),e(Gt,Um),e(O,Rm),e(O,Vt),e(Vt,Vc),e(Vc,Gm),e(Vt,Vm),e(Vt,Wc),e(Wc,Wm),e(Vt,Fm),e(O,Hm),e(O,Wt),e(Wt,Fc),e(Fc,Ym),e(Wt,Bm),e(Wt,Hc),e(Hc,Jm),e(Wt,Km),e(O,Qm),e(O,Ft),e(Ft,Yc),e(Yc,Xm),e(Ft,Zm),e(Ft,Bc),e(Bc,eh),e(Ft,th),e(O,ah),e(O,Ht),e(Ht,Jc),e(Jc,rh),e(Ht,sh),e(Ht,Kc),e(Kc,oh),e(Ht,ch),e(O,lh),e(O,Yt),e(Yt,Qc),e(Qc,nh),e(Yt,ph),e(Yt,co),e(co,ih),e(Yt,dh),e(O,mh),e(O,Bt),e(Bt,Xc),e(Xc,hh),e(Bt,fh),e(Bt,Zc),e(Zc,uh),e(Bt,gh),e(O,_h),e(O,Jt),e(Jt,el),e(el,$h),e(Jt,vh),e(Jt,tl),e(tl,bh),e(Jt,wh),e(x,yh),e(x,ue),w(xr,ue,null),e(ue,jh),e(ue,al),e(al,Ah),e(ue,kh),w(Kt,ue,null),e(x,Eh),e(x,ge),w(Pr,ge,null),e(ge,xh),e(ge,rl),e(rl,Ph),e(ge,Dh),w(Qt,ge,null),e(x,Th),e(x,K),w(Dr,K,null),e(K,zh),e(K,ot),e(ot,Ch),e(ot,sl),e(sl,Oh),e(ot,Lh),e(ot,ol),e(ol,Sh),e(ot,Ih),e(K,qh),e(K,Tr),e(Tr,Nh),e(Tr,cl),e(cl,Mh),e(Tr,Uh),e(K,Rh),w(Xt,K,null),e(x,Gh),e(x,_e),w(zr,_e,null),e(_e,Vh),e(_e,Cr),e(Cr,Wh),e(Cr,ll),e(ll,Fh),e(Cr,Hh),e(_e,Yh),w(Zt,_e,null),e(x,Bh),e(x,$e),w(Or,$e,null),e($e,Jh),e($e,Lr),e(Lr,Kh),e(Lr,nl),e(nl,Qh),e(Lr,Xh),e($e,Zh),w(ea,$e,null),e(x,ef),e(x,ve),w(Sr,ve,null),e(ve,tf),e(ve,Ir),e(Ir,af),e(Ir,pl),e(pl,rf),e(Ir,sf),e(ve,of),w(ta,ve,null),e(x,cf),e(x,be),w(qr,be,null),e(be,lf),e(be,il),e(il,nf),e(be,pf),w(aa,be,null),e(x,df),e(x,Q),w(Nr,Q,null),e(Q,mf),e(Q,Mr),e(Mr,hf),e(Mr,dl),e(dl,ff),e(Mr,uf),e(Q,gf),e(Q,ml),e(ml,_f),e(Q,$f),w(ra,Q,null),e(x,vf),e(x,we),w(Ur,we,null),e(we,bf),e(we,Rr),e(Rr,wf),e(Rr,hl),e(hl,yf),e(Rr,jf),e(we,Af),w(sa,we,null),e(x,kf),e(x,ye),w(Gr,ye,null),e(ye,Ef),e(ye,Vr),e(Vr,xf),e(Vr,lo),e(lo,Pf),e(Vr,Df),e(ye,Tf),w(oa,ye,null),e(x,zf),e(x,je),w(Wr,je,null),e(je,Cf),e(je,ie),e(ie,Of),e(ie,fl),e(fl,Lf),e(ie,Sf),e(ie,ul),e(ul,If),e(ie,qf),e(ie,gl),e(gl,Nf),e(ie,Mf),e(je,Uf),w(ca,je,null),e(x,Rf),e(x,W),w(Fr,W,null),e(W,Gf),e(W,Hr),e(Hr,Vf),e(Hr,_l),e(_l,Wf),e(Hr,Ff),e(W,Hf),w(la,W,null),e(W,Yf),w(na,W,null),e(W,Bf),w(pa,W,null),e(x,Jf),e(x,X),w(Yr,X,null),e(X,Kf),e(X,$l),e($l,Qf),e(X,Xf),w(ia,X,null),e(X,Zf),w(da,X,null),e(x,eu),e(x,Z),w(Br,Z,null),e(Z,tu),e(Z,vl),e(vl,au),e(Z,ru),e(Z,bl),e(bl,su),e(Z,ou),w(ma,Z,null),e(x,cu),e(x,ee),w(Jr,ee,null),e(ee,lu),e(ee,wl),e(wl,nu),e(ee,pu),e(ee,yl),e(yl,iu),e(ee,du),w(ha,ee,null),e(x,mu),e(x,te),w(Kr,te,null),e(te,hu),e(te,Qr),e(Qr,fu),e(Qr,jl),e(jl,uu),e(Qr,gu),e(te,_u),e(te,Xr),e(Xr,$u),e(Xr,Al),e(Al,vu),e(Xr,bu),e(te,wu),w(fa,te,null),e(x,yu),e(x,Ae),w(Zr,Ae,null),e(Ae,ju),e(Ae,es),e(es,Au),e(es,kl),e(kl,ku),e(es,Eu),e(Ae,xu),w(ua,Ae,null),e(x,Pu),e(x,ke),w(ts,ke,null),e(ke,Du),e(ke,as),e(as,Tu),e(as,El),e(El,zu),e(as,Cu),e(ke,Ou),w(ga,ke,null),e(x,Lu),e(x,Ee),w(rs,Ee,null),e(Ee,Su),e(Ee,ss),e(ss,Iu),e(ss,xl),e(xl,qu),e(ss,Nu),e(Ee,Mu),w(_a,Ee,null),e(x,Uu),e(x,xe),w(os,xe,null),e(xe,Ru),e(xe,cs),e(cs,Gu),e(cs,Pl),e(Pl,Vu),e(cs,Wu),e(xe,Fu),w($a,xe,null),e(x,Hu),e(x,Pe),w(ls,Pe,null),e(Pe,Yu),e(Pe,ns),e(ns,Bu),e(ns,Dl),e(Dl,Ju),e(ns,Ku),e(Pe,Qu),w(va,Pe,null),e(x,Xu),e(x,De),w(ps,De,null),e(De,Zu),e(De,Tl),e(Tl,eg),e(De,tg),w(ba,De,null),e(x,ag),e(x,ae),w(is,ae,null),e(ae,rg),e(ae,ds),e(ds,sg),e(ds,zl),e(zl,og),e(ds,cg),e(ae,lg),w(wa,ae,null),e(ae,ng),w(ya,ae,null),e(x,pg),e(x,Te),w(ms,Te,null),e(Te,ig),e(Te,hs),e(hs,dg),e(hs,no),e(no,mg),e(hs,hg),e(Te,fg),w(ja,Te,null),e(x,ug),e(x,ze),w(fs,ze,null),e(ze,gg),e(ze,us),e(us,_g),e(us,po),e(po,$g),e(us,vg),e(ze,bg),w(Aa,ze,null),e(x,wg),e(x,Ce),w(gs,Ce,null),e(Ce,yg),e(Ce,_s),e(_s,jg),e(_s,io),e(io,Ag),e(_s,kg),e(Ce,Eg),w(ka,Ce,null),e(x,xg),e(x,Oe),w($s,Oe,null),e(Oe,Pg),e(Oe,vs),e(vs,Dg),e(vs,mo),e(mo,Tg),e(vs,zg),e(Oe,Cg),w(Ea,Oe,null),e(x,Og),e(x,Le),w(bs,Le,null),e(Le,Lg),e(Le,ws),e(ws,Sg),e(ws,Cl),e(Cl,Ig),e(ws,qg),e(Le,Ng),w(xa,Le,null),e(x,Mg),e(x,re),w(ys,re,null),e(re,Ug),e(re,ct),e(ct,Rg),e(ct,Ol),e(Ol,Gg),e(ct,Vg),e(ct,Ll),e(Ll,Wg),e(ct,Fg),e(re,Hg),e(re,Sl),e(Sl,Yg),e(re,Bg),w(Pa,re,null),e(x,Jg),e(x,F),w(js,F,null),e(F,Kg),e(F,de),e(de,Qg),e(de,Il),e(Il,Xg),e(de,Zg),e(de,ql),e(ql,e_),e(de,t_),e(de,Nl),e(Nl,a_),e(de,r_),e(F,s_),e(F,Ml),e(Ml,o_),e(F,c_),w(Da,F,null),e(F,l_),w(Ta,F,null),e(x,n_),e(x,M),w(As,M,null),e(M,p_),e(M,lt),e(lt,i_),e(lt,Ul),e(Ul,d_),e(lt,m_),e(lt,ho),e(ho,h_),e(lt,f_),e(M,u_),e(M,Rl),e(Rl,g_),e(M,__),e(M,Gl),e(Gl,Vl),e(Vl,$_),e(M,v_),e(M,V),e(V,b_),e(V,Wl),e(Wl,w_),e(V,y_),e(V,Fl),e(Fl,j_),e(V,A_),e(V,Hl),e(Hl,k_),e(V,E_),e(V,Yl),e(Yl,x_),e(V,P_),e(V,fo),e(fo,D_),e(V,T_),e(M,z_),w(za,M,null),e(x,C_),e(x,U),w(ks,U,null),e(U,O_),e(U,nt),e(nt,L_),e(nt,Bl),e(Bl,S_),e(nt,I_),e(nt,uo),e(uo,q_),e(nt,N_),e(U,M_),e(U,Jl),e(Jl,U_),e(U,R_),e(U,Kl),e(Kl,Ql),e(Ql,G_),e(U,V_),e(U,I),e(I,W_),e(I,Xl),e(Xl,F_),e(I,H_),e(I,Zl),e(Zl,Y_),e(I,B_),e(I,en),e(en,J_),e(I,K_),e(I,tn),e(tn,Q_),e(I,X_),e(I,an),e(an,Z_),e(I,e$),e(I,rn),e(rn,t$),e(I,a$),e(I,go),e(go,r$),e(I,s$),e(U,o$),w(Ca,U,null),e(x,c$),e(x,Se),w(Es,Se,null),e(Se,l$),e(Se,xs),e(xs,n$),e(xs,sn),e(sn,p$),e(xs,i$),e(Se,d$),w(Oa,Se,null),e(x,m$),e(x,R),w(Ps,R,null),e(R,h$),e(R,on),e(on,f$),e(R,u$),e(R,N),e(N,g$),e(N,cn),e(cn,_$),e(N,$$),e(N,ln),e(ln,v$),e(N,b$),e(N,nn),e(nn,w$),e(N,y$),e(N,pn),e(pn,j$),e(N,A$),e(N,dn),e(dn,k$),e(N,E$),e(N,mn),e(mn,x$),e(N,P$),e(R,D$),e(R,Ds),e(Ds,T$),e(Ds,hn),e(hn,z$),e(Ds,C$),e(R,O$),w(La,R,null),e(R,L$),w(Sa,R,null),e(x,S$),e(x,Ie),w(Ts,Ie,null),e(Ie,I$),e(Ie,pt),e(pt,q$),e(pt,fn),e(fn,N$),e(pt,M$),e(pt,un),e(un,U$),e(pt,R$),e(Ie,G$),w(Ia,Ie,null),e(x,V$),e(x,se),w(zs,se,null),e(se,W$),e(se,gn),e(gn,F$),e(se,H$),e(se,qa),e(qa,Y$),e(qa,Na),e(Na,B$),e(Na,_n),e(_n,J$),e(Na,K$),e(qa,Q$),e(qa,Ma),e(Ma,X$),e(Ma,$n),e($n,Z$),e(Ma,ev),e(se,tv),w(Ua,se,null),e(x,av),e(x,qe),w(Cs,qe,null),e(qe,rv),e(qe,it),e(it,sv),e(it,vn),e(vn,ov),e(it,cv),e(it,_o),e(_o,lv),e(it,nv),e(qe,pv),w(Ra,qe,null),e(x,iv),e(x,Ne),w(Os,Ne,null),e(Ne,dv),e(Ne,bn),e(bn,mv),e(Ne,hv),w(Ga,Ne,null),Yp=!0},p(a,[_]){const Ls={};_&2&&(Ls.$$scope={dirty:_,ctx:a}),gt.$set(Ls);const wn={};_&2&&(wn.$$scope={dirty:_,ctx:a}),$t.$set(wn);const yn={};_&2&&(yn.$$scope={dirty:_,ctx:a}),Kt.$set(yn);const jn={};_&2&&(jn.$$scope={dirty:_,ctx:a}),Qt.$set(jn);const Ss={};_&2&&(Ss.$$scope={dirty:_,ctx:a}),Xt.$set(Ss);const An={};_&2&&(An.$$scope={dirty:_,ctx:a}),Zt.$set(An);const Is={};_&2&&(Is.$$scope={dirty:_,ctx:a}),ea.$set(Is);const kn={};_&2&&(kn.$$scope={dirty:_,ctx:a}),ta.$set(kn);const En={};_&2&&(En.$$scope={dirty:_,ctx:a}),aa.$set(En);const xn={};_&2&&(xn.$$scope={dirty:_,ctx:a}),ra.$set(xn);const Pn={};_&2&&(Pn.$$scope={dirty:_,ctx:a}),sa.$set(Pn);const dt={};_&2&&(dt.$$scope={dirty:_,ctx:a}),oa.$set(dt);const mt={};_&2&&(mt.$$scope={dirty:_,ctx:a}),ca.$set(mt);const Dn={};_&2&&(Dn.$$scope={dirty:_,ctx:a}),la.$set(Dn);const Tn={};_&2&&(Tn.$$scope={dirty:_,ctx:a}),na.$set(Tn);const qs={};_&2&&(qs.$$scope={dirty:_,ctx:a}),pa.$set(qs);const zn={};_&2&&(zn.$$scope={dirty:_,ctx:a}),ia.$set(zn);const me={};_&2&&(me.$$scope={dirty:_,ctx:a}),da.$set(me);const Cn={};_&2&&(Cn.$$scope={dirty:_,ctx:a}),ma.$set(Cn);const On={};_&2&&(On.$$scope={dirty:_,ctx:a}),ha.$set(On);const Ln={};_&2&&(Ln.$$scope={dirty:_,ctx:a}),fa.$set(Ln);const Ns={};_&2&&(Ns.$$scope={dirty:_,ctx:a}),ua.$set(Ns);const Va={};_&2&&(Va.$$scope={dirty:_,ctx:a}),ga.$set(Va);const Sn={};_&2&&(Sn.$$scope={dirty:_,ctx:a}),_a.$set(Sn);const In={};_&2&&(In.$$scope={dirty:_,ctx:a}),$a.$set(In);const $o={};_&2&&($o.$$scope={dirty:_,ctx:a}),va.$set($o);const qn={};_&2&&(qn.$$scope={dirty:_,ctx:a}),ba.$set(qn);const Ms={};_&2&&(Ms.$$scope={dirty:_,ctx:a}),wa.$set(Ms);const Nn={};_&2&&(Nn.$$scope={dirty:_,ctx:a}),ya.$set(Nn);const Us={};_&2&&(Us.$$scope={dirty:_,ctx:a}),ja.$set(Us);const Mn={};_&2&&(Mn.$$scope={dirty:_,ctx:a}),Aa.$set(Mn);const Un={};_&2&&(Un.$$scope={dirty:_,ctx:a}),ka.$set(Un);const Rn={};_&2&&(Rn.$$scope={dirty:_,ctx:a}),Ea.$set(Rn);const Rs={};_&2&&(Rs.$$scope={dirty:_,ctx:a}),xa.$set(Rs);const Gn={};_&2&&(Gn.$$scope={dirty:_,ctx:a}),Pa.$set(Gn);const Vn={};_&2&&(Vn.$$scope={dirty:_,ctx:a}),Da.$set(Vn);const Wn={};_&2&&(Wn.$$scope={dirty:_,ctx:a}),Ta.$set(Wn);const Wa={};_&2&&(Wa.$$scope={dirty:_,ctx:a}),za.$set(Wa);const Fn={};_&2&&(Fn.$$scope={dirty:_,ctx:a}),Ca.$set(Fn);const Hn={};_&2&&(Hn.$$scope={dirty:_,ctx:a}),Oa.$set(Hn);const Gs={};_&2&&(Gs.$$scope={dirty:_,ctx:a}),La.$set(Gs);const Yn={};_&2&&(Yn.$$scope={dirty:_,ctx:a}),Sa.$set(Yn);const Bn={};_&2&&(Bn.$$scope={dirty:_,ctx:a}),Ia.$set(Bn);const Jn={};_&2&&(Jn.$$scope={dirty:_,ctx:a}),Ua.$set(Jn);const Vs={};_&2&&(Vs.$$scope={dirty:_,ctx:a}),Ra.$set(Vs);const Kn={};_&2&&(Kn.$$scope={dirty:_,ctx:a}),Ga.$set(Kn)},i(a){Yp||(y(t.$$.fragment,a),y(rr.$$.fragment,a),y(gt.$$.fragment,a),y($t.$$.fragment,a),y(or.$$.fragment,a),y(cr.$$.fragment,a),y(lr.$$.fragment,a),y(nr.$$.fragment,a),y(pr.$$.fragment,a),y(ir.$$.fragment,a),y(dr.$$.fragment,a),y(mr.$$.fragment,a),y(hr.$$.fragment,a),y(fr.$$.fragment,a),y(ur.$$.fragment,a),y(gr.$$.fragment,a),y(_r.$$.fragment,a),y($r.$$.fragment,a),y(vr.$$.fragment,a),y(br.$$.fragment,a),y(wr.$$.fragment,a),y(yr.$$.fragment,a),y(jr.$$.fragment,a),y(Ar.$$.fragment,a),y(kr.$$.fragment,a),y(Er.$$.fragment,a),y(xr.$$.fragment,a),y(Kt.$$.fragment,a),y(Pr.$$.fragment,a),y(Qt.$$.fragment,a),y(Dr.$$.fragment,a),y(Xt.$$.fragment,a),y(zr.$$.fragment,a),y(Zt.$$.fragment,a),y(Or.$$.fragment,a),y(ea.$$.fragment,a),y(Sr.$$.fragment,a),y(ta.$$.fragment,a),y(qr.$$.fragment,a),y(aa.$$.fragment,a),y(Nr.$$.fragment,a),y(ra.$$.fragment,a),y(Ur.$$.fragment,a),y(sa.$$.fragment,a),y(Gr.$$.fragment,a),y(oa.$$.fragment,a),y(Wr.$$.fragment,a),y(ca.$$.fragment,a),y(Fr.$$.fragment,a),y(la.$$.fragment,a),y(na.$$.fragment,a),y(pa.$$.fragment,a),y(Yr.$$.fragment,a),y(ia.$$.fragment,a),y(da.$$.fragment,a),y(Br.$$.fragment,a),y(ma.$$.fragment,a),y(Jr.$$.fragment,a),y(ha.$$.fragment,a),y(Kr.$$.fragment,a),y(fa.$$.fragment,a),y(Zr.$$.fragment,a),y(ua.$$.fragment,a),y(ts.$$.fragment,a),y(ga.$$.fragment,a),y(rs.$$.fragment,a),y(_a.$$.fragment,a),y(os.$$.fragment,a),y($a.$$.fragment,a),y(ls.$$.fragment,a),y(va.$$.fragment,a),y(ps.$$.fragment,a),y(ba.$$.fragment,a),y(is.$$.fragment,a),y(wa.$$.fragment,a),y(ya.$$.fragment,a),y(ms.$$.fragment,a),y(ja.$$.fragment,a),y(fs.$$.fragment,a),y(Aa.$$.fragment,a),y(gs.$$.fragment,a),y(ka.$$.fragment,a),y($s.$$.fragment,a),y(Ea.$$.fragment,a),y(bs.$$.fragment,a),y(xa.$$.fragment,a),y(ys.$$.fragment,a),y(Pa.$$.fragment,a),y(js.$$.fragment,a),y(Da.$$.fragment,a),y(Ta.$$.fragment,a),y(As.$$.fragment,a),y(za.$$.fragment,a),y(ks.$$.fragment,a),y(Ca.$$.fragment,a),y(Es.$$.fragment,a),y(Oa.$$.fragment,a),y(Ps.$$.fragment,a),y(La.$$.fragment,a),y(Sa.$$.fragment,a),y(Ts.$$.fragment,a),y(Ia.$$.fragment,a),y(zs.$$.fragment,a),y(Ua.$$.fragment,a),y(Cs.$$.fragment,a),y(Ra.$$.fragment,a),y(Os.$$.fragment,a),y(Ga.$$.fragment,a),Yp=!0)},o(a){j(t.$$.fragment,a),j(rr.$$.fragment,a),j(gt.$$.fragment,a),j($t.$$.fragment,a),j(or.$$.fragment,a),j(cr.$$.fragment,a),j(lr.$$.fragment,a),j(nr.$$.fragment,a),j(pr.$$.fragment,a),j(ir.$$.fragment,a),j(dr.$$.fragment,a),j(mr.$$.fragment,a),j(hr.$$.fragment,a),j(fr.$$.fragment,a),j(ur.$$.fragment,a),j(gr.$$.fragment,a),j(_r.$$.fragment,a),j($r.$$.fragment,a),j(vr.$$.fragment,a),j(br.$$.fragment,a),j(wr.$$.fragment,a),j(yr.$$.fragment,a),j(jr.$$.fragment,a),j(Ar.$$.fragment,a),j(kr.$$.fragment,a),j(Er.$$.fragment,a),j(xr.$$.fragment,a),j(Kt.$$.fragment,a),j(Pr.$$.fragment,a),j(Qt.$$.fragment,a),j(Dr.$$.fragment,a),j(Xt.$$.fragment,a),j(zr.$$.fragment,a),j(Zt.$$.fragment,a),j(Or.$$.fragment,a),j(ea.$$.fragment,a),j(Sr.$$.fragment,a),j(ta.$$.fragment,a),j(qr.$$.fragment,a),j(aa.$$.fragment,a),j(Nr.$$.fragment,a),j(ra.$$.fragment,a),j(Ur.$$.fragment,a),j(sa.$$.fragment,a),j(Gr.$$.fragment,a),j(oa.$$.fragment,a),j(Wr.$$.fragment,a),j(ca.$$.fragment,a),j(Fr.$$.fragment,a),j(la.$$.fragment,a),j(na.$$.fragment,a),j(pa.$$.fragment,a),j(Yr.$$.fragment,a),j(ia.$$.fragment,a),j(da.$$.fragment,a),j(Br.$$.fragment,a),j(ma.$$.fragment,a),j(Jr.$$.fragment,a),j(ha.$$.fragment,a),j(Kr.$$.fragment,a),j(fa.$$.fragment,a),j(Zr.$$.fragment,a),j(ua.$$.fragment,a),j(ts.$$.fragment,a),j(ga.$$.fragment,a),j(rs.$$.fragment,a),j(_a.$$.fragment,a),j(os.$$.fragment,a),j($a.$$.fragment,a),j(ls.$$.fragment,a),j(va.$$.fragment,a),j(ps.$$.fragment,a),j(ba.$$.fragment,a),j(is.$$.fragment,a),j(wa.$$.fragment,a),j(ya.$$.fragment,a),j(ms.$$.fragment,a),j(ja.$$.fragment,a),j(fs.$$.fragment,a),j(Aa.$$.fragment,a),j(gs.$$.fragment,a),j(ka.$$.fragment,a),j($s.$$.fragment,a),j(Ea.$$.fragment,a),j(bs.$$.fragment,a),j(xa.$$.fragment,a),j(ys.$$.fragment,a),j(Pa.$$.fragment,a),j(js.$$.fragment,a),j(Da.$$.fragment,a),j(Ta.$$.fragment,a),j(As.$$.fragment,a),j(za.$$.fragment,a),j(ks.$$.fragment,a),j(Ca.$$.fragment,a),j(Es.$$.fragment,a),j(Oa.$$.fragment,a),j(Ps.$$.fragment,a),j(La.$$.fragment,a),j(Sa.$$.fragment,a),j(Ts.$$.fragment,a),j(Ia.$$.fragment,a),j(zs.$$.fragment,a),j(Ua.$$.fragment,a),j(Cs.$$.fragment,a),j(Ra.$$.fragment,a),j(Os.$$.fragment,a),j(Ga.$$.fragment,a),Yp=!1},d(a){r(p),a&&r(g),a&&r(m),A(t),a&&r(ft),a&&r(J),a&&r(ar),a&&r(We),A(rr),a&&r(np),a&&r(Hs),a&&r(pp),a&&r(he),a&&r(ip),A(gt,a),a&&r(dp),a&&r(He),a&&r(mp),A($t,a),a&&r(hp),a&&r(vt),a&&r(fp),a&&r(Ye),A(or),a&&r(up),a&&r(Be),A(cr),a&&r(gp),a&&r(Je),a&&r(_p),A(lr,a),a&&r($p),a&&r(Ke),A(nr),a&&r(vp),a&&r(Qe),A(pr),a&&r(bp),a&&r(At),a&&r(wp),A(ir,a),a&&r(yp),a&&r(kt),a&&r(jp),A(dr,a),a&&r(Ap),a&&r(Xe),A(mr),a&&r(kp),a&&r(xt),a&&r(Ep),A(hr,a),a&&r(xp),a&&r(Pt),a&&r(Pp),A(fr,a),a&&r(Dp),a&&r(Ze),A(ur),a&&r(Tp),a&&r(eo),a&&r(zp),A(gr,a),a&&r(Cp),A(_r,a),a&&r(Op),a&&r(et),A($r),a&&r(Lp),a&&r(zt),a&&r(Sp),a&&r(tt),A(vr),a&&r(Ip),a&&r(Ot),a&&r(qp),A(br,a),a&&r(Np),a&&r(fe),a&&r(Mp),A(wr,a),a&&r(Up),a&&r(at),A(yr),a&&r(Rp),a&&r(Y),a&&r(Gp),a&&r(rt),A(jr),a&&r(Vp),a&&r(Nt),a&&r(Wp),A(Ar,a),a&&r(Fp),a&&r(st),A(kr),a&&r(Hp),a&&r(x),A(Er),A(xr),A(Kt),A(Pr),A(Qt),A(Dr),A(Xt),A(zr),A(Zt),A(Or),A(ea),A(Sr),A(ta),A(qr),A(aa),A(Nr),A(ra),A(Ur),A(sa),A(Gr),A(oa),A(Wr),A(ca),A(Fr),A(la),A(na),A(pa),A(Yr),A(ia),A(da),A(Br),A(ma),A(Jr),A(ha),A(Kr),A(fa),A(Zr),A(ua),A(ts),A(ga),A(rs),A(_a),A(os),A($a),A(ls),A(va),A(ps),A(ba),A(is),A(wa),A(ya),A(ms),A(ja),A(fs),A(Aa),A(gs),A(ka),A($s),A(Ea),A(bs),A(xa),A(ys),A(Pa),A(js),A(Da),A(Ta),A(As),A(za),A(ks),A(Ca),A(Es),A(Oa),A(Ps),A(La),A(Sa),A(Ts),A(Ia),A(zs),A(Ua),A(Cs),A(Ra),A(Os),A(Ga)}}}const H2={local:"accelerator",sections:[{local:"quick-adaptation-of-your-code",title:"Quick adaptation of your code"},{local:"advanced-recommendations",sections:[{local:"printing",title:"Printing"},{local:"executing-processes",sections:[{local:"once-on-a-single-server",title:"Once on a single server"},{local:"only-ever-once-across-all-servers",title:"Only ever once across all servers"},{local:"on-specific-processes",title:"On specific processes"}],title:"Executing processes"},{local:"synchronicity-control",title:"Synchronicity control"},{local:"saving-and-loading",title:"Saving and loading"},{local:"operations",title:"Operations"},{local:"gradient-accumulation",title:"Gradient Accumulation"}],title:"Advanced recommendations"},{local:"accelerate.Accelerator",title:"Overall API documentation:"}],title:"Accelerator"};function Y2(E){return X1(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ew extends B1{constructor(p){super();J1(this,p,Y2,F2,K1,{})}}export{ew as default,H2 as metadata};
